package com.connor.jd.operations;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.connor.jd.plm.utils.DBConnectionUtil;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCSession;

public class CreateTableOperation {
	private static Connection con = null;
	private static Statement ps = null;
	private static ResultSet rs = null;
	private static TCSession session;

	public static void create() {
		session = (TCSession) AIFUtility.getCurrentApplication().getSession();
		String createTable1 = "CREATE TABLE JD2_Component (test_type VARCHAR(255),test_project VARCHAR(255),test_time VARCHAR(255),test_num NUMBER,test_cost FLOAT, test_id NUMBER primary key)";
		String createSeq1 = "CREATE sequence component_id_seq minvalue 1 nomaxvalue INCREMENT BY 1 START WITH 1 nocache";
		String createTRG1 = "CREATE or REPLACE TRIGGER component_id_ins_trg before INSERT ON JD2_COMPONENT for each ROW BEGIN SELECT component_id_seq.Nextval into : new.TEST_ID from dual; END;";

		String createTable2 = "CREATE TABLE JD2_Machine (test_type VARCHAR(255),test_project VARCHAR(255),test_cost FLOAT, test_id NUMBER primary key)";
		String createSeq2 = "CREATE sequence machine_id_seq minvalue 1 nomaxvalue INCREMENT BY 1 START WITH 1 nocache";
		String createTRG2 = "CREATE or REPLACE TRIGGER machine_id_ins_trg before INSERT ON JD2_MACHINE for each ROW BEGIN SELECT machine_id_seq.Nextval into : new.TEST_ID from dual; END;";
		String[] sqls = { createTable1, createSeq1, createTRG1, createTable2, createSeq2, createTRG2 };
		try {
			con = DBConnectionUtil.dbConn(session);
			String sqlString = "SELECT count(*) from user_tables WHERE table_name='JD2_COMPONENT'";
			if (con == null) {
				System.out.print("ʧ");
			} else {
				ps = con.createStatement();
				rs = ps.executeQuery(sqlString);
				while (rs.next()) {
					System.out.println(rs.getInt(1));
					if (rs.getInt(1) == 0) {
						for (int i = 0; i < sqls.length; i++) {
							ps = con.createStatement();
							ps.execute(sqls[i]);
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (rs != null) {
				try {
					rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
			if (ps != null) {
				try {
					ps.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
			if (con != null) {
				try {
					con.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}
			}
		}

	}
}
