package com.connor.jd.plm.action;

import java.util.Arrays;
import java.util.Comparator;

import javax.swing.JOptionPane;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class AddHLBOMAction extends AbstractAIFAction {

	private AbstractAIFApplication app;
	private TCSession session;

	public AddHLBOMAction(AbstractAIFApplication arg0, String arg1) {
		super(arg0, arg1);
		// TODO Auto-generated constructor stub
		this.app = arg0;
		this.session = (TCSession) app.getSession();
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		TCComponent target = (TCComponent) app.getTargetComponent();
		TCComponentItemRevision rev = null;
		if (target instanceof TCComponentItemRevision) {
			rev = (TCComponentItemRevision) target;
		} else if (target instanceof TCComponentItem) {
			try {
				rev = ((TCComponentItem) target).getLatestItemRevision();
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		try {
			TCComponent[] revs = rev.getRelatedComponents("JD2_HLBOM");
			String itemId = rev.getProperty("item_id");
			String itemName = rev.getProperty("object_name");
			TCComponentItem newItem = null;
			session.getUserService().call("bs_bypass", new Object[] { true });
			if (revs.length == 0) {
				newItem = rev.saveAsItem(itemId + "-1", null);
			} else {
				Arrays.sort(revs, new Comparator<TCComponent>() {
					@Override
					public int compare(TCComponent o1, TCComponent o2) {
						// TODO Auto-generated method stub
						try {
							return o1.getProperty("item_id").compareTo(o2.getProperty("item_id"));
						} catch (TCException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						return 0;
					}
				});
				String str = revs[revs.length - 1].getProperty("item_id");
				str = str.split("-")[1];
				newItem = rev.saveAsItem(itemId + "-" + (Integer.parseInt(str) + 1), null);
			}
			rev.add("JD2_HLBOM", newItem);
			TCComponentItemRevision newRev = newItem.getLatestItemRevision();
			TCComponent[] comps = newRev.getRelatedComponents("JD2_HLBOM");
			System.out.println(Arrays.toString(comps));
			newRev.cutOperation("JD2_HLBOM", comps);
			newRev.lock();
			newRev.setProperty("jd2_ishl", "1");
			newRev.save();
			newRev.unlock();

			rev.refresh();
			MessageBox.post("ɹ", "ʾ", MessageBox.WARNING);
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, e.getMessage(), "", JOptionPane.ERROR_MESSAGE);
		} finally {
			try {
				session.getUserService().call("bs_bypass", new Object[] { false });
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

}
