package com.connor.jd.plm.action;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.common.actions.AbstractAIFAction;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.util.MessageBox;

public class WLTZReviseAction extends AbstractAIFAction {
	private AbstractAIFApplication app;
	private TCSession session;

	public WLTZReviseAction(AbstractAIFApplication arg0, String arg1) {
		super(arg0, arg1);
		this.app = arg0;
		this.session = (TCSession) app.getSession();
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		TCComponent target = (TCComponent) AIFUtility.getCurrentApplication().getTargetComponent();
		String[] allow = getPrefStrArray("jd2_wltz_Revise_allow");
		List<String> list = Arrays.asList(allow);
		for (String s : list) {
			System.out.println(s);
		}

		TCComponentItemRevision rev;
		if (target instanceof TCComponentItemRevision) {
			rev = (TCComponentItemRevision) target;
		} else if (target instanceof TCComponentBOMLine) {
			try {
				rev = ((TCComponentBOMLine) target).getItemRevision();
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				MessageBox.post(e.getMessage(), "", MessageBox.ERROR);
				return;
			}
		} else {
			MessageBox.post("ǰͲ޶ͷ࣡", "", MessageBox.ERROR);
			return;
		}
		try {
			String type = rev.getType();
			System.out.println(type);
			if (!list.contains(type)) {
				MessageBox.post("ǰͲ޶ͷ࣡", "", MessageBox.ERROR);
				return;
			}
			TCComponentItem item = rev.getItem();
			session.getUserService().call("bs_bypass", new Object[] { true });
			TCComponentItemRevision newRev = rev.saveAs(item.getNewRev());
			session.getUserService().call("bs_bypass", new Object[] { false });
			TCComponentICO ico = rev.getClassificationObjects()[0];
			ICSProperty[] oldICSProps = ico.getICSProperties(true);
			int[] ids = new int[oldICSProps.length];
			String[] values = new String[oldICSProps.length];
			for (int i = 0; i < oldICSProps.length; i++) {
				System.out.println(oldICSProps[i].getId() + "=====>" + oldICSProps[i].getValue());
				ids[i] = oldICSProps[i].getId();
				values[i] = oldICSProps[i].getValue();
			}
			JSONObject json = new JSONObject();
			json.put("ids", ids);
			json.put("values", values);
			String prop = json.toString();
			prop = prop.replace("\"", "\\\"");
			System.out.println("prop:" + prop);
			String uid = newRev.getUid();
			System.out.println("uid:" + uid);
			String cid = rev.getClassificationClass();
			System.out.println("cid:" + cid);
			String server = getPrefStr("jd2_server_ip");
			if (server == null || "".equals(server)) {
				MessageBox.post("δjd2_server_ipѡ", "", MessageBox.ERROR);
				return;
			}
			String url = "http://" + server + ":8880/sendClassification";
			Map<String, Object> paramMap = new HashMap<String, Object>();
			paramMap.put("uid", uid);
			paramMap.put("cid", cid);
			paramMap.put("prop", prop);
			final String URL = url;
			final Map<String, Object> PARAMMAP = paramMap;
			new Thread(new Runnable() {

				@Override
				public void run() {
					// TODO Auto-generated method stub
					cn.hutool.http.HttpUtil.post(URL, PARAMMAP);
					System.out.println("success");
				}
			}).start();
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * ȡֵѡ
	 * 
	 * @param prefName
	 * @return
	 */
	public String getPrefStr(String prefName) {
		TCPreferenceService service = session.getPreferenceService();
		String str = service.getString(TCPreferenceService.TC_preference_site, prefName);
		if (str == null) {
			str = new String("");
		}
		return str;
	}

	/**
	 * ȡֵѡ
	 * 
	 * @param prefName
	 * @return
	 */
	public String[] getPrefStrArray(String prefName) {
		TCPreferenceService service = session.getPreferenceService();
		String[] strs = service.getStringArray(TCPreferenceService.TC_preference_site, prefName);
		service.getStringValues(prefName);
		service.getStringValue(prefName);
		if (strs == null) {
			strs = new String[] { "" };
		}
		return strs;
	}

}
