package com.connor.jd.plm.dialog;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.connor.jd.plm.beans.ClassPropBean;
import com.connor.jd.plm.utils.ExcelInfoScanner;
import com.connor.jd.plm.utils.JDMethodUtil;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCClassificationService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSAdminClass;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.kernel.ics.ICSPropertyDescription;
import com.teamcenter.rac.util.MessageBox;

import cn.hutool.json.JSONObject;

public class EditClassificationDialog extends AbstractAIFDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private AbstractAIFApplication app;
	private TCSession session;
	private TCComponent target;
	private Map<String, JComponent> propMap;
	private TCClassificationService myService;
	final EditClassificationDialog DIALOG = this;
	private TCComponentItemRevision rev;
	private int[] ids;
	private String[] values;
	private String[] names;

	public EditClassificationDialog(AbstractAIFApplication app) throws TCException {
		this.app = app;
		this.session = (TCSession) app.getSession();
		this.myService = session.getClassificationService();
		this.target = (TCComponent) AIFUtility.getCurrentApplication().getTargetComponent();
		System.out.println(target.getType());
		System.out.println(target instanceof TCComponentItemRevision ? "" : "");

		if (target instanceof TCComponentItemRevision) {
			try {
				initUI();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			MessageBox.post("ѡ汾", "", MessageBox.ERROR);
		}
	}

	private void initUI() {
		this.setTitle("޸ķ");
		this.setAutoRequestFocus(true);
		this.setResizable(false);
		this.setAlwaysOnTop(true);

		JPanel rootPanel = new JPanel();
		rootPanel.setLayout(null);
		rootPanel.setPreferredSize(new Dimension(300, 350));

		Map<Integer, ClassPropBean> displayMap = new LinkedHashMap<Integer, ClassPropBean>();
		propMap = new HashMap<String, JComponent>();
		TCComponentItemRevision rev = (TCComponentItemRevision) target;

		try {
			if (rev.getClassificationClass() != null || !"".equals(rev.getClassificationClass())) {
				try {
					TCComponentICO ico = rev.getClassificationObjects()[0];

					ICSProperty[] props = ico.getICSProperties(true);
					ICSPropertyDescription[] desc = ico.getICSPropertyDescriptors();
					for (int i = 0; i < props.length; i++) {
						System.out.println(props[i].getId() + "===>" + props[i].getValue());
						displayMap.put(props[i].getId(),
								new ClassPropBean(props[i].getId(), desc[i].getName(), props[i].getValue()));
					}
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			} else {
				MessageBox.post("ǰ汾δ", "", MessageBox.ERROR);
				return;
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		if (displayMap.size() == 0) {
			return;
		}

		String uid = JDMethodUtil.getPrefStr("jd_class_prop_option", session);
		System.out.println("uid======>" + uid);
		Map<Integer, String> propOption = null;
		try {
			TCComponent comp = session.stringToComponent(uid);
			if (comp != null) {
				TCComponentDataset op = (TCComponentDataset) comp;
				String temp = System.getenv("temp");
				String[] types = op.getProperty("ref_names").split(",");
				File optionFile = op.getFiles(types[0], temp)[0];
				optionFile.deleteOnExit();
				System.out.println(rev.getItem().getProperty("object_type"));
				propOption = ExcelInfoScanner.getClassPropOptions(optionFile.getPath(),
						rev.getItem().getProperty("object_type"));
				System.out.println("propOption count======>" + propOption.size());
			}
		} catch (TCException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

		JPanel content = new JPanel();
		content.setLayout(null);
		content.setPreferredSize(new Dimension(300, displayMap.size() * (25 + 10)));

		int num = 0;
		for (Entry<Integer, ClassPropBean> entry : displayMap.entrySet()) {
			JLabel label = new JLabel(entry.getValue().getName() + "");
			label.setBounds(10, num * 35 + 10, 100, 25);
			if (propOption != null && propOption.containsKey(entry.getKey())) {
				String[] items = propOption.get(entry.getKey()).split(",");
				JComboBox<String> combo = new JComboBox<String>();
				combo.addItem(" ");
				for (String s : items) {
					combo.addItem(s);
				}
				combo.setSelectedItem(entry.getValue().getValue());
				if (combo.getSelectedItem() == null || combo.getSelectedIndex() < 0) {
					combo.addItem(entry.getValue().getValue());
					combo.setSelectedItem(entry.getValue().getValue());
				}
				combo.setBounds(130, num * 35 + 10, 150, 25);
				propMap.put(entry.getValue().getName(), combo);
				content.add(combo);
			} else {
				JTextField text = new JTextField(entry.getValue().getValue());
				text.setBounds(130, num * 35 + 10, 150, 25);
				propMap.put(entry.getValue().getName(), text);
				content.add(text);
			}

			content.add(label);

			num++;
		}

		JButton okBtn = new JButton("ȷ");
		okBtn.setBounds(40, 310, 100, 25);
		okBtn.setSelected(true);
		okBtn.addActionListener(ok());
		JButton cancelBtn = new JButton("ȡ");
		cancelBtn.setBounds(160, 310, 100, 25);
		cancelBtn.addActionListener(cancel());

		JScrollPane jsp = new JScrollPane(content);
		jsp.setBounds(0, 0, 300, 300);
		jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		rootPanel.add(jsp);
		rootPanel.add(okBtn);
		rootPanel.add(cancelBtn);
		this.add(rootPanel);
		this.pack();
		this.centerToScreen();
		this.showDialog();
	}

	private ActionListener ok() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				rev = (TCComponentItemRevision) target;

				saveClassification(rev);
//				try {
//					System.out.println(rev.getProperty("object_string"));
//					if (rev.getType().equals("JD2_GTBJRevision")) {
//						TCComponent[] comps = rev.getReferenceListProperty("TC_Is_Represented_By");
//						System.out.println(comps.length);
//						for (int i = 0; i < comps.length; i++) {
//							if (comps[i].getType().equals("JD2_XYJTZRevision")) {
//								System.out.println("object_string:" + comps[i].getProperty("object_string"));
//								TCComponentItemRevision tzrev = (TCComponentItemRevision) comps[i];
//								saveClassification(tzrev);
//							}
//						}
//					}
//				} catch (TCException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//				}
				DIALOG.disposeDialog();
			}
		};
	}

	private ActionListener cancel() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				DIALOG.disposeDialog();
			}
		};
	}

	private boolean saveClassification(TCComponentItemRevision rev) {

		try {
			TCComponentICO[] icoS = rev.getClassificationObjects();
			String classID = rev.getClassificationClass();
			if (icoS == null || icoS.length == 0) {
				return false;
			}
			for (int i = 0; i < icoS.length; i++) {
				TCComponentICO ico = icoS[i];
				ICSPropertyDescription[] desc = ico.getICSPropertyDescriptors();
				ICSProperty[] oldICSProps = ico.getICSProperties(true);
				ids = new int[oldICSProps.length];
				values = new String[oldICSProps.length];
				names = new String[oldICSProps.length];
				for (int j = 0; j < oldICSProps.length; j++) {
					ids[j] = oldICSProps[j].getId();
					if (propMap.get(desc[j].getName()) instanceof JComboBox) {
						String str = ((JComboBox<String>) propMap.get(desc[j].getName())).getSelectedItem().toString();
						values[j] = " ".equals(str) ? "" : str;
					} else {
						values[j] = ((JTextField) propMap.get(desc[j].getName())).getText();
					}
					names[j] = desc[j].getName();
				}

				JSONObject obj = new JSONObject();
				obj.put("ids", ids);
				obj.put("values", values);
				String prop = obj.toString();
//				prop = prop.replace("\"", "\\\"");
				String server = JDMethodUtil.getPrefStr("jd2_server_ip", session);
				if (server == null || "".equals(server)) {
					MessageBox.post("δjd2_server_ipѡ", "", MessageBox.ERROR);
					return false;
				}
				String url = "http://" + server + ":8880/api/sendClassification";
				Map<String, Object> paramMap = new HashMap<String, Object>();
				String uid = rev.getUid();
				paramMap.put("uid", uid);
				paramMap.put("cid", classID);
				paramMap.put("prop", prop);
				System.out.println(url);
				System.out.println(prop);
				final String URL = url;
				final Map<String, Object> PARAMMAP = paramMap;
				final TCComponentItemRevision REV = rev;

				new Thread(new Runnable() {
					@Override
					public void run() {
						// TODO Auto-generated method stub
						cn.hutool.http.HttpUtil.post(URL, PARAMMAP);
						finish();
					}
				}).start();
			}
		} catch (TCException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		return true;
	}

	private void finish() {
		try {
			rev.refresh();
			String[] prefArr = JDMethodUtil.getPrefStrArray("jd2_custom_display_name", session);
			String classAddress = getClassificationAddress(rev.getClassificationClass());
			System.out.println("classAddress=====>" + classAddress);
			for (String pref : prefArr) {
				String[] className = pref.split(":")[0].split("/");
				if (classAddress.contains(className[0]) && classAddress.contains(className[1])) {
					String[] prefClassNamesArr = pref.split(":")[1].split(",");
					System.out.println("pref class porp names=====>" + Arrays.toString(prefClassNamesArr));
					StringBuilder builder = new StringBuilder();
					for (int i = 0; i < prefClassNamesArr.length; i++) {
						System.out.println(prefClassNamesArr[i]);
						for (int ii = 0; ii < names.length; ii++) {
							System.out.println(names[ii]);
							if (prefClassNamesArr[i].equals(names[ii]) && !"".equals(values[ii].trim())) {
								builder.append(values[ii] + ",");
							}
						}
					}
					String temp = builder.toString().substring(0, builder.toString().length() - 1);
					System.out.println("class porp values=====>" + temp);
					session.getUserService().call("bs_bypass", new Object[] { true });
					rev.lock();
					rev.setProperty("jd2_flfh", temp);
					rev.save();
					rev.unlock();
					session.getUserService().call("bs_bypass", new Object[] { false });
					break;
				}
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			JOptionPane.showMessageDialog(null, "ѡjd2_custom_display_name\r\n" + e.getMessage(), "ʾ",
					JOptionPane.WARNING_MESSAGE);
			return;
		}
		System.out.println("success");
	}

	private String getClassificationAddress(String classId) throws TCException {
		ICSAdminClass clazz = session.getClassificationService().newICSAdminClass();
		clazz.load(classId);
		if ("ICM".equals(clazz.askClassId())) {
			return "";
		}
		return clazz.getName() + "=>" + getClassificationAddress(clazz.getParent());
	}

}
