package com.connor.jd.plm.dialogs;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.RowSorter;
import javax.swing.filechooser.FileSystemView;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableRowSorter;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;

import com.connor.jd.plm.beans.BOMManageTableBean;
import com.connor.jd.plm.beans.CheckBoxPo;
import com.connor.jd.plm.beans.CustomLovBean;
import com.connor.jd.plm.beans.ResultData;
import com.connor.jd.plm.table.MyCellEditor4;
import com.connor.jd.plm.table.MyCellRenderer;
import com.connor.jd.plm.utils.DBConnectionUtil;
import com.connor.jd.plm.utils.DBUtil;
import com.connor.jd.plm.utils.DatePickerUtil;
import com.connor.jd.plm.utils.DialogUtil;
import com.connor.jd.plm.utils.JDMethodUtil;
import com.connor.jd.plm.utils.KeyValComboBox;
import com.connor.jd.plm.utils.StringCreateUtil;
import com.eltima.components.ui.DatePicker;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.TCTypeService;

import cn.hutool.core.util.StrUtil;
import cn.hutool.db.Db;
import cn.hutool.db.Entity;
import cn.hutool.db.sql.Condition;

public class BOMManagementFrame extends JFrame {
	private AbstractAIFApplication app;
	private TCSession session;
	private CardLayout rootSwitch = new CardLayout();
	private String[] colDisplayNames = new String[] { "ѡ", "", "Ӽ", "λ", "", "״̬" };
	private String[] colDisplayNames2 = new String[] { "", "޸û", "ʱ", "" };
	private JPanel root;
	private Map<String, Object> uiMap = new HashMap<String, Object>();
	private Map<String, BOMManageTableBean> tableDataMap = new HashMap<String, BOMManageTableBean>();
	private BOMManagementFrame $this;
	private List<Entity> logDataList;
	private Map<String, TCComponentBOMWindow> winMap = new HashMap<String, TCComponentBOMWindow>();
	private TCComponentItemRevision targetRev;
	private TCComponentItemRevision targetRev2;
	private boolean isLogcreated = false;
	private int doIndex = 0;
	private boolean complate = false;
	private List<String> checkItemType = new ArrayList<String>();

	public BOMManagementFrame(AbstractAIFApplication app) {
		super();
		this.app = app;
		this.session = (TCSession) app.getSession();
		TCComponent target = (TCComponent) AIFUtility.getCurrentApplication().getTargetComponent();
		try {
			target.setProperty("object_string", "test");
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		$this = this;
		String[] prefArray = JDMethodUtil.getPrefStrArray("connor_bom_check_type", session);
		if (prefArray != null) {
			checkItemType = Arrays.asList(prefArray);
		}
		init();
	}

	private void init() {
		this.setTitle("BOM");
		this.setSize(new Dimension(1200, 800));
		this.setLayout(new BorderLayout());
		this.setResizable(false);
		this.setAlwaysOnTop(true);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setLocationRelativeTo(null);

		Container container = this.getContentPane();
		container.setLayout(new BorderLayout());
		container.setPreferredSize(new Dimension(1200, 800));

		TCTypeService typeService = session.getTypeService();
		Vector<CheckBoxPo> unitVector = new Vector<CheckBoxPo>();
		try {
			TCComponent[] uomArray = typeService.getTypeComponent("UnitOfMeasure").extent();
			unitVector.add(new CheckBoxPo(" ", " "));
			for (TCComponent comp : uomArray) {
				unitVector.add(new CheckBoxPo(comp.toString(), comp));
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// ͷ
		JPanel topBtnPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		JButton[] topBtns = new JButton[5];
		topBtns[0] = new JButton("滻");
		topBtns[1] = new JButton("");
		topBtns[2] = new JButton("");
		topBtns[3] = new JButton("ɾ");
		topBtns[4] = new JButton("־");
//		topBtns[5] = new JButton("԰ť");
		for (JButton btn : topBtns) {
			topBtnPanel.add(btn);
			btn.addActionListener(panelSwitch());
		}
		container.add(topBtnPanel, BorderLayout.NORTH);

		// root
		root = new JPanel(rootSwitch);

		// 滻
		JPanel p1 = new JPanel();
		p1.setLayout(null);

		// 滻
		JPanel p1Left = new JPanel();
		p1Left.setLayout(null);
		p1Left.setBounds(0, 0, 800, 800);
		p1Left.setBorder(BorderFactory.createEtchedBorder());

		JLabel p1TargetLabel = new JLabel("Ŀϱ");
		p1TargetLabel.setBounds(20, 20, 100, 25);
		JButton p1TargetBtn = new JButton();
		uiMap.put("p1TargetBtn", p1TargetBtn);
		p1TargetBtn.setBounds(130, 20, 400, 25);
		JLabel p1ReplaceLabel = new JLabel("滻ϱ");
		p1ReplaceLabel.setBounds(20, 60, 100, 25);
		JButton p1ReplaceBtn = new JButton();
		uiMap.put("p1ReplaceBtn", p1ReplaceBtn);
		p1ReplaceBtn.setBounds(130, 60, 400, 25);
		JLabel p1UnitLabel = new JLabel("λ");
		p1UnitLabel.setBounds(560, 60, 50, 25);
		KeyValComboBox p1UnitCombo = new KeyValComboBox(unitVector);
		uiMap.put("p1UnitCombo", p1UnitCombo);
		p1UnitCombo.setBounds(610, 60, 50, 25);
		JLabel p1NumLabel = new JLabel("");
		p1NumLabel.setBounds(680, 60, 50, 25);
		JTextField p1NumText = new JTextField();
		uiMap.put("p1NumText", p1NumText);
		p1NumText.setBounds(730, 60, 50, 25);

		JCheckBox p1SelectAll = new JCheckBox("ȫѡ");
		uiMap.put("p1SelectAll", p1SelectAll);
		p1SelectAll.setBounds(20, 100, 100, 25);
		DefaultTableModel p1model = new DefaultTableModel(colDisplayNames, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				if (paramInt2 == 0) {
					return true;
				}
				return false;
			}

			@Override
			public Class<?> getColumnClass(int paramInt) {
				// TODO Auto-generated method stub
				if (paramInt == 0) {
					return Integer.class;
				}
				return super.getColumnClass(paramInt);
			}
		};
		JTable p1Table = new JTable(p1model);
		uiMap.put("p1Table", p1Table);
		p1Table.getColumnModel().getColumn(0).setMinWidth(60);
		p1Table.getColumnModel().getColumn(0).setMaxWidth(60);
		p1Table.getColumnModel().getColumn(1).setMinWidth(200);
		p1Table.getColumnModel().getColumn(2).setMinWidth(200);
		p1Table.getColumnModel().getColumn(3).setMinWidth(100);
		p1Table.getColumnModel().getColumn(4).setMinWidth(100);
		p1Table.getColumnModel().getColumn(5).setMinWidth(100);
		p1Table.getColumnModel().getColumn(0).setCellRenderer(new MyCellRenderer());
		p1Table.getColumnModel().getColumn(0).setCellEditor(new MyCellEditor4(new JTextField()));
		p1Table.setRowHeight(25);
		p1Table.setAutoscrolls(true);
		p1Table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		p1Table.getTableHeader().setReorderingAllowed(false);
		RowSorter<DefaultTableModel> p1sorter = new TableRowSorter<DefaultTableModel>(p1model);
		p1Table.setRowSorter(p1sorter);
		JScrollPane p1jsp = new JScrollPane(p1Table);
		p1jsp.setBounds(20, 130, 760, 500);

		JButton p1BottomBtn1 = new JButton("");
		p1BottomBtn1.setBounds(100, 650, 100, 25);
		JButton p1BottomBtn2 = new JButton("滻");
		p1BottomBtn2.setBounds(300, 650, 100, 25);
		JButton p1BottomBtn3 = new JButton("ȡ");
		p1BottomBtn3.setBounds(500, 650, 100, 25);

		p1Left.add(p1TargetLabel);
		p1Left.add(p1TargetBtn);
		p1Left.add(p1ReplaceLabel);
		p1Left.add(p1ReplaceBtn);
		p1Left.add(p1UnitLabel);
		p1Left.add(p1UnitCombo);
		p1Left.add(p1NumLabel);
		p1Left.add(p1NumText);
		p1Left.add(p1SelectAll);
		p1Left.add(p1jsp);
		p1Left.add(p1BottomBtn1);
		p1Left.add(p1BottomBtn2);
		p1Left.add(p1BottomBtn3);

		// 滻ұ
		JPanel p1Right = new JPanel();
		uiMap.put("p1Right", p1Right);
		p1Right.setLayout(null);
		p1Right.setBounds(800, 0, 400, 800);
		p1Right.setBorder(BorderFactory.createEtchedBorder());

		JScrollPane p1TreePanel = new JScrollPane();
		uiMap.put("p1TreePanel", p1TreePanel);
		p1TreePanel.setBounds(20, 130, 360, 500);
		p1Right.add(p1TreePanel);

		// ¼
		p1SelectAll.addItemListener(selectAll(p1Table));
		p1Table.addMouseListener(showTree(p1Right));
		p1BottomBtn3.addActionListener(cancel());
		p1BottomBtn1.addActionListener(batchRevise(p1Table, p1SelectAll));
		p1BottomBtn2.addActionListener(batchReplace());
		p1TargetBtn.addActionListener(clickSearch(p1Table, p1SelectAll));
		p1ReplaceBtn.addActionListener(clickSearch(null, null));

		p1.add(p1Left);
		p1.add(p1Right);

		// 
		JPanel p2 = new JPanel();
		p2.setLayout(null);

		// 
		JPanel p2Left = new JPanel();
		p2Left.setLayout(null);
		p2Left.setBounds(0, 0, 800, 800);
		p2Left.setBorder(BorderFactory.createEtchedBorder());

		JLabel p2TargetLabel = new JLabel("Ŀϱ");
		p2TargetLabel.setBounds(20, 20, 100, 25);
		JButton p2TargetBtn = new JButton();
		uiMap.put("p2TargetBtn", p2TargetBtn);
		p2TargetBtn.setBounds(130, 20, 400, 25);
		JLabel p2ChangeNumLabel = new JLabel("");
		p2ChangeNumLabel.setBounds(20, 60, 100, 25);
		JTextField p2NumText = new JTextField();
		uiMap.put("p2NumText", p2NumText);
		p2NumText.setBounds(130, 60, 50, 25);

		JCheckBox p2SelectAll = new JCheckBox("ȫѡ");
		uiMap.put("p2SelectAll", p2SelectAll);
		p2SelectAll.setBounds(20, 100, 100, 25);
		DefaultTableModel p2model = new DefaultTableModel(colDisplayNames, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				if (paramInt2 == 0) {
					return true;
				}
				return false;
			}

			@Override
			public Class<?> getColumnClass(int paramInt) {
				// TODO Auto-generated method stub
				if (paramInt == 0) {
					return Integer.class;
				}
				return super.getColumnClass(paramInt);
			}
		};
		JTable p2Table = new JTable(p2model);
		uiMap.put("p2Table", p2Table);
		p2Table.getColumnModel().getColumn(0).setMinWidth(60);
		p2Table.getColumnModel().getColumn(0).setMaxWidth(60);
		p2Table.getColumnModel().getColumn(1).setMinWidth(200);
		p2Table.getColumnModel().getColumn(2).setMinWidth(200);
		p2Table.getColumnModel().getColumn(3).setMinWidth(100);
		p2Table.getColumnModel().getColumn(4).setMinWidth(100);
		p2Table.getColumnModel().getColumn(5).setMinWidth(100);
		p2Table.getColumnModel().getColumn(0).setCellRenderer(new MyCellRenderer());
		p2Table.getColumnModel().getColumn(0).setCellEditor(new MyCellEditor4(new JTextField()));
		p2Table.setRowHeight(25);
		p2Table.setAutoscrolls(true);
		p2Table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		p2Table.getTableHeader().setReorderingAllowed(false);
		RowSorter<DefaultTableModel> p2sorter = new TableRowSorter<DefaultTableModel>(p2model);
		p2Table.setRowSorter(p2sorter);
		JScrollPane p2jsp = new JScrollPane(p2Table);
		p2jsp.setBounds(20, 130, 760, 500);

		JButton p2BottomBtn1 = new JButton("");
		p2BottomBtn1.setBounds(100, 650, 100, 25);
		JButton p2BottomBtn2 = new JButton("");
		p2BottomBtn2.setBounds(300, 650, 100, 25);
		JButton p2BottomBtn3 = new JButton("ȡ");
		p2BottomBtn3.setBounds(500, 650, 100, 25);

		p2Left.add(p2TargetLabel);
		p2Left.add(p2TargetBtn);
		p2Left.add(p2ChangeNumLabel);
		p2Left.add(p2NumText);
		p2Left.add(p2SelectAll);
		p2Left.add(p2jsp);
		p2Left.add(p2BottomBtn1);
		p2Left.add(p2BottomBtn2);
		p2Left.add(p2BottomBtn3);

		// ұ
		JPanel p2Right = new JPanel();
		uiMap.put("p2Right", p2Right);
		p2Right.setLayout(null);
		p2Right.setBounds(800, 0, 400, 800);
		p2Right.setBorder(BorderFactory.createEtchedBorder());

		JScrollPane p2TreePanel = new JScrollPane();
		uiMap.put("p2TreePanel", p2TreePanel);
		p2TreePanel.setBounds(20, 130, 360, 500);
		p2Right.add(p2TreePanel);

		// ¼
		p2SelectAll.addItemListener(selectAll(p2Table));
		p2Table.addMouseListener(showTree(p2Right));
		p2BottomBtn3.addActionListener(cancel());
		p2BottomBtn1.addActionListener(batchRevise(p2Table, p2SelectAll));
		p2BottomBtn2.addActionListener(batchModify());
		p2TargetBtn.addActionListener(clickSearch(p2Table, p2SelectAll));

		p2.add(p2Left);
		p2.add(p2Right);

		// 
		JPanel p3 = new JPanel();
		p3.setLayout(null);

		// 
		JPanel p3Left = new JPanel();
		p3Left.setLayout(null);
		p3Left.setBounds(0, 0, 800, 800);
		p3Left.setBorder(BorderFactory.createEtchedBorder());

		JLabel p3TargetLabel = new JLabel("οϱ");
		p3TargetLabel.setBounds(20, 20, 100, 25);
		JButton p3TargetBtn = new JButton();
		uiMap.put("p3TargetBtn", p3TargetBtn);
		p3TargetBtn.setBounds(130, 20, 400, 25);
		JLabel p3ReplaceLabel = new JLabel("ϱ");
		p3ReplaceLabel.setBounds(20, 60, 100, 25);
		JButton p3AddBtn = new JButton();
		uiMap.put("p3AddBtn", p3AddBtn);
		p3AddBtn.setBounds(130, 60, 400, 25);
		JLabel p3UnitLabel = new JLabel("λ");
		p3UnitLabel.setBounds(560, 60, 50, 25);
		KeyValComboBox p3UnitCombo = new KeyValComboBox(unitVector);
		uiMap.put("p3UnitCombo", p3UnitCombo);
		p3UnitCombo.setBounds(610, 60, 50, 25);
		JLabel p3NumLabel = new JLabel("");
		p3NumLabel.setBounds(680, 60, 50, 25);
		JTextField p3NumText = new JTextField();
		uiMap.put("p3NumText", p3NumText);
		p3NumText.setBounds(730, 60, 50, 25);

		JCheckBox p3SelectAll = new JCheckBox("ȫѡ");
		uiMap.put("p3SelectAll", p3SelectAll);
		p3SelectAll.setBounds(20, 100, 100, 25);
		DefaultTableModel p3model = new DefaultTableModel(colDisplayNames, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				if (paramInt2 == 0) {
					return true;
				}
				return false;
			}

			@Override
			public Class<?> getColumnClass(int paramInt) {
				// TODO Auto-generated method stub
				if (paramInt == 0) {
					return Integer.class;
				}
				return super.getColumnClass(paramInt);
			}
		};
		JTable p3Table = new JTable(p3model);
		uiMap.put("p3Table", p3Table);
		p3Table.getColumnModel().getColumn(0).setMinWidth(60);
		p3Table.getColumnModel().getColumn(0).setMaxWidth(60);
		p3Table.getColumnModel().getColumn(1).setMinWidth(200);
		p3Table.getColumnModel().getColumn(2).setMinWidth(200);
		p3Table.getColumnModel().getColumn(3).setMinWidth(100);
		p3Table.getColumnModel().getColumn(4).setMinWidth(100);
		p3Table.getColumnModel().getColumn(5).setMinWidth(100);
		p3Table.getColumnModel().getColumn(0).setCellRenderer(new MyCellRenderer());
		p3Table.getColumnModel().getColumn(0).setCellEditor(new MyCellEditor4(new JTextField()));
		p3Table.setRowHeight(25);
		p3Table.setAutoscrolls(true);
		p3Table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		p3Table.getTableHeader().setReorderingAllowed(false);
		RowSorter<DefaultTableModel> p3sorter = new TableRowSorter<DefaultTableModel>(p3model);
		p3Table.setRowSorter(p3sorter);
		JScrollPane p3jsp = new JScrollPane(p3Table);
		p3jsp.setBounds(20, 130, 760, 500);

		JButton p3BottomBtn1 = new JButton("");
		p3BottomBtn1.setBounds(100, 650, 100, 25);
		JButton p3BottomBtn2 = new JButton("");
		p3BottomBtn2.setBounds(300, 650, 100, 25);
		JButton p3BottomBtn3 = new JButton("ȡ");
		p3BottomBtn3.setBounds(500, 650, 100, 25);

		p3Left.add(p3TargetLabel);
		p3Left.add(p3TargetBtn);
		p3Left.add(p3ReplaceLabel);
		p3Left.add(p3AddBtn);
		p3Left.add(p3UnitLabel);
		p3Left.add(p3UnitCombo);
		p3Left.add(p3NumLabel);
		p3Left.add(p3NumText);
		p3Left.add(p3SelectAll);
		p3Left.add(p3jsp);
		p3Left.add(p3BottomBtn1);
		p3Left.add(p3BottomBtn2);
		p3Left.add(p3BottomBtn3);

		// ұ
		JPanel p3Right = new JPanel();
		uiMap.put("p3Right", p3Right);
		p3Right.setLayout(null);
		p3Right.setBounds(800, 0, 400, 800);
		p3Right.setBorder(BorderFactory.createEtchedBorder());

		JScrollPane p3TreePanel = new JScrollPane();
		uiMap.put("p3TreePanel", p3TreePanel);
		p3TreePanel.setBounds(20, 130, 360, 500);
		p3Right.add(p3TreePanel);

		// ¼
		p3SelectAll.addItemListener(selectAll(p3Table));
		p3Table.addMouseListener(showTree(p3Right));
		p3BottomBtn3.addActionListener(cancel());
		p3BottomBtn1.addActionListener(batchRevise(p3Table, p3SelectAll));
		p3BottomBtn2.addActionListener(batchAdd());
		p3TargetBtn.addActionListener(clickSearch(p3Table, p3SelectAll));
		p3AddBtn.addActionListener(clickSearch(null, null));

		p3.add(p3Left);
		p3.add(p3Right);

		// ɾ
		JPanel p4 = new JPanel();
		p4.setLayout(null);

		// ɾ
		JPanel p4Left = new JPanel();
		p4Left.setLayout(null);
		p4Left.setBounds(0, 0, 800, 800);
		p4Left.setBorder(BorderFactory.createEtchedBorder());

		JLabel p4TargetLabel = new JLabel("Ŀϱ");
		p4TargetLabel.setBounds(20, 20, 100, 25);
		JButton p4TargetBtn = new JButton();
		uiMap.put("p4TargetBtn", p4TargetBtn);
		p4TargetBtn.setBounds(130, 20, 400, 25);

		JCheckBox p4SelectAll = new JCheckBox("ȫѡ");
		uiMap.put("p4SelectAll", p4SelectAll);
		p4SelectAll.setBounds(20, 100, 100, 25);
		DefaultTableModel p4model = new DefaultTableModel(colDisplayNames, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				if (paramInt2 == 0) {
					return true;
				}
				return false;
			}

			@Override
			public Class<?> getColumnClass(int paramInt) {
				// TODO Auto-generated method stub
				if (paramInt == 0) {
					return Integer.class;
				}
				return super.getColumnClass(paramInt);
			}
		};
		JTable p4Table = new JTable(p4model);
		uiMap.put("p4Table", p4Table);
		p4Table.getColumnModel().getColumn(0).setMinWidth(60);
		p4Table.getColumnModel().getColumn(0).setMaxWidth(60);
		p4Table.getColumnModel().getColumn(1).setMinWidth(200);
		p4Table.getColumnModel().getColumn(2).setMinWidth(200);
		p4Table.getColumnModel().getColumn(3).setMinWidth(100);
		p4Table.getColumnModel().getColumn(4).setMinWidth(100);
		p4Table.getColumnModel().getColumn(5).setMinWidth(100);
		p4Table.getColumnModel().getColumn(0).setCellRenderer(new MyCellRenderer());
		p4Table.getColumnModel().getColumn(0).setCellEditor(new MyCellEditor4(new JTextField()));
		p4Table.setRowHeight(25);
		p4Table.setAutoscrolls(true);
		p4Table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		p4Table.getTableHeader().setReorderingAllowed(false);
		RowSorter<DefaultTableModel> p4sorter = new TableRowSorter<DefaultTableModel>(p4model);
		p4Table.setRowSorter(p4sorter);
		JScrollPane p4jsp = new JScrollPane(p4Table);
		p4jsp.setBounds(20, 130, 760, 500);

		JButton p4BottomBtn1 = new JButton("");
		p4BottomBtn1.setBounds(100, 650, 100, 25);
		JButton p4BottomBtn2 = new JButton("ɾ");
		p4BottomBtn2.setBounds(300, 650, 100, 25);
		JButton p4BottomBtn3 = new JButton("ȡ");
		p4BottomBtn3.setBounds(500, 650, 100, 25);

		p4Left.add(p4TargetLabel);
		p4Left.add(p4TargetBtn);
		p4Left.add(p4SelectAll);
		p4Left.add(p4jsp);
		p4Left.add(p4BottomBtn1);
		p4Left.add(p4BottomBtn2);
		p4Left.add(p4BottomBtn3);

		// ұ
		JPanel p4Right = new JPanel();
		uiMap.put("p4Right", p4Right);
		p4Right.setLayout(null);
		p4Right.setBounds(800, 0, 400, 800);
		p4Right.setBorder(BorderFactory.createEtchedBorder());

		JScrollPane p4TreePanel = new JScrollPane();
		uiMap.put("p4TreePanel", p4TreePanel);
		p4TreePanel.setBounds(20, 130, 360, 500);
		p4Right.add(p4TreePanel);

		// ¼
		p4SelectAll.addItemListener(selectAll(p4Table));
		p4Table.addMouseListener(showTree(p4Right));
		p4BottomBtn3.addActionListener(cancel());
		p4BottomBtn1.addActionListener(batchRevise(p4Table, p4SelectAll));
		p4BottomBtn2.addActionListener(batchRemove());
		p4TargetBtn.addActionListener(clickSearch(p4Table, p4SelectAll));

		p4.add(p4Left);
		p4.add(p4Right);

		// ־
		JPanel p5 = new JPanel();
		p5.setLayout(null);

		JLabel p5UserLabel = new JLabel("޸û");
		p5UserLabel.setBounds(20, 40, 70, 25);
		JTextField p5UserText = new JTextField();
		uiMap.put("p5UserText", p5UserText);
		p5UserText.setBounds(100, 40, 150, 25);
		JLabel p5timeLabel = new JLabel("޸ʱ");
		p5timeLabel.setBounds(300, 40, 70, 25);
		DatePicker p5timeStartText = DatePickerUtil.getDatePicker(null);
		uiMap.put("p5timeStartText", p5timeStartText);
		p5timeStartText.setBounds(380, 40, 100, 25);
		JLabel toLabel = new JLabel("");
		toLabel.setBounds(490, 40, 20, 25);
		DatePicker p5timeEndText = DatePickerUtil.getDatePicker(null);
		uiMap.put("p5timeEndText", p5timeEndText);
		p5timeEndText.setBounds(520, 40, 100, 25);
		JLabel p5ContentLabel = new JLabel("޸");
		p5ContentLabel.setBounds(670, 40, 70, 25);
		JTextArea p5ContentText = new JTextArea();
		uiMap.put("p5ContentText", p5ContentText);
		p5ContentText.setLineWrap(true);
		p5ContentText.setWrapStyleWord(true);
		JScrollPane p5Contentjsp = new JScrollPane(p5ContentText);
		p5Contentjsp.setBounds(750, 20, 200, 80);
		JButton p5Search = new JButton("");
		uiMap.put("p5Search", p5Search);
		p5Search.setBounds(1000, 40, 60, 25);
		JButton p5Download = new JButton("־");
		uiMap.put("p5Download", p5Download);
		p5Download.setBounds(1080, 40, 100, 25);

		DefaultTableModel p5model = new DefaultTableModel(colDisplayNames2, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				return false;
			}

			@Override
			public Class<?> getColumnClass(int paramInt) {
				// TODO Auto-generated method stub
				if (paramInt == 0) {
					return Integer.class;
				}
				return super.getColumnClass(paramInt);
			}
		};
		JTable p5Table = new JTable(p5model);
		uiMap.put("p5Table", p5Table);
		p5Table.getColumnModel().getColumn(0).setMinWidth(60);
		p5Table.getColumnModel().getColumn(0).setMaxWidth(60);
		p5Table.getColumnModel().getColumn(1).setMinWidth(200);
		p5Table.getColumnModel().getColumn(2).setMinWidth(200);
		p5Table.getColumnModel().getColumn(3).setMinWidth(700);
		p5Table.setRowHeight(25);
		p5Table.setAutoscrolls(true);
		p5Table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		p5Table.getTableHeader().setReorderingAllowed(false);
		RowSorter<DefaultTableModel> p5sorter = new TableRowSorter<DefaultTableModel>(p5model);
		p5Table.setRowSorter(p5sorter);
		JScrollPane p5jsp = new JScrollPane(p5Table);
		p5jsp.setBounds(20, 130, 1160, 600);

		// ¼
		p5Search.addActionListener(searchLog());
		p5Download.addActionListener(downloadLog(p5Table));
		p5UserText.addKeyListener(logSearchEnter());
		p5timeStartText.addKeyListener(logSearchEnter());
		p5timeEndText.addKeyListener(logSearchEnter());

		p5.add(p5UserLabel);
		p5.add(p5UserText);
		p5.add(p5timeLabel);
		p5.add(p5timeStartText);
		p5.add(toLabel);
		p5.add(p5timeEndText);
		p5.add(p5ContentLabel);
		p5.add(p5Contentjsp);
		p5.add(p5Search);
		p5.add(p5Download);
		p5.add(p5jsp);

		root.add("batchReplace", p1);
		root.add("batchModify", p2);
		root.add("batchAdd", p3);
		root.add("batchRemove", p4);
		root.add("updateLog", p5);

		rootSwitch.show(root, "batchReplace");
		container.add(root, BorderLayout.CENTER);
		this.setVisible(true);
	}

	private ActionListener panelSwitch() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String text = ((JButton) e.getSource()).getText();
				switch (text) {
				case "滻":
					clearTable((JTable) uiMap.get("p1Table"), (JCheckBox) uiMap.get("p1SelectAll"));
					((JScrollPane) uiMap.get("p1TreePanel")).removeAll();
					rootSwitch.show(root, "batchReplace");
					break;
				case "":
					clearTable((JTable) uiMap.get("p2Table"), (JCheckBox) uiMap.get("p2SelectAll"));
					((JScrollPane) uiMap.get("p2TreePanel")).removeAll();
					rootSwitch.show(root, "batchModify");
					break;
				case "":
					clearTable((JTable) uiMap.get("p3Table"), (JCheckBox) uiMap.get("p3SelectAll"));
					((JScrollPane) uiMap.get("p3TreePanel")).removeAll();
					rootSwitch.show(root, "batchAdd");
					break;
				case "ɾ":
					clearTable((JTable) uiMap.get("p4Table"), (JCheckBox) uiMap.get("p4SelectAll"));
					((JScrollPane) uiMap.get("p4TreePanel")).removeAll();
					rootSwitch.show(root, "batchRemove");
					break;
				case "־":
					createLogDataSourceTable();
					clearTable((JTable) uiMap.get("p5Table"), null);
					rootSwitch.show(root, "updateLog");
					break;
				default:
//					createLogDataSourceTable();
				}
			}
		};
	}

	private void showWhereUesd(JTable table, JCheckBox selectAll) {
		DefaultTableModel model = (DefaultTableModel) table.getModel();
		// TODO Auto-generated method stub
		clearTable(table, selectAll);
		if (table == null || targetRev == null) {
			return;
		}
		long startTime = System.currentTimeMillis();
		List<Object[]> tableDataList = new ArrayList<Object[]>();
		try {
			String revString = targetRev.getProperty("object_string");
			TCComponent[] usedComps = targetRev.whereUsed((short) 0);
			System.out.println("װ======>" + usedComps.length);
			TCTypeService service = session.getTypeService();
			TCComponentBOMWindowType winType = (TCComponentBOMWindowType) service.getTypeComponent("BOMWindow");

			tableDataMap.clear();
			Map<String, TCComponent> usedMap = removeDuplicates(usedComps);
			for (Entry<String, TCComponent> entry : usedMap.entrySet()) {
				TCComponentItemRevision parentRev = (TCComponentItemRevision) entry.getValue();
				String parentString = parentRev.getProperty("object_string");
				TCComponent[] statusArray = parentRev.getRelatedComponents("release_status_list");
				String status = "";
				if (statusArray != null && statusArray.length > 0) {
					status = statusArray[statusArray.length - 1].getProperty("object_name");
				}
				TCComponentBOMWindow win = winType.create(null);
				TCComponentBOMLine topLine = win.setWindowTopLine(parentRev.getItem(), parentRev, null, null);
				winMap.put(parentString, win);
				AIFComponentContext[] aifs = topLine.getChildren();
				for (AIFComponentContext aif : aifs) {
					TCComponentBOMLine child = (TCComponentBOMLine) aif.getComponent();
					if (revString.equals(child.getItemRevision().getProperty("object_string"))) {

						String unit = child.getProperty("bl_uom");
						String num = child.getProperty("bl_quantity");

						Object[] rowData = new Object[] { new JCheckBox(), parentString, revString, unit, num, status };
						System.out.println(Arrays.toString(rowData));
						tableDataList.add(rowData);
						tableDataMap.put(parentString,
								new BOMManageTableBean(parentString, revString, parentRev, targetRev, topLine, child));
						break;
					}
				}
			}
		} catch (TCException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		if (tableDataList == null || tableDataList.size() == 0) {
			JOptionPane.showMessageDialog($this, "ҵӦ󣬵öûκװ䣬ȷϱǷȷ", "ʾ", JOptionPane.WARNING_MESSAGE);
			return;
		}

		for (Object[] rowData : tableDataList) {
			model.addRow(rowData);
		}
		table.revalidate();
		table.repaint();
		System.out.println("װʾɣʱ" + (System.currentTimeMillis() - startTime) + "ms");
	}

	private MouseAdapter showTree(JPanel panelRight) {
		return new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON1 && e.getClickCount() == 2) {
					JTable table = (JTable) e.getSource();
					String parentString = table.getValueAt(table.getSelectedRow(), 1).toString();
					System.out.println("select row=====>" + table.getSelectedRow());
					System.out.println("parentName=====>" + parentString);
					CustomLovBean lovBean = null;
					try {
						lovBean = new CustomLovBean(tableDataMap.get(parentString).getChildString());
						CustomLovBean subBean = new CustomLovBean(parentString);
						lovBean.addSub(subBean);
						getTreeData(tableDataMap.get(parentString).getParentRev(), subBean);
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}

					panelRight.removeAll();
					JTree tree = createTree(lovBean);
					JScrollPane treePanel = new JScrollPane(tree);
					treePanel.setBounds(20, 130, 360, 500);
					panelRight.add(treePanel);
					panelRight.revalidate();
					panelRight.repaint();
				}
			}
		};
	}

	private void getTreeData(TCComponent rev, CustomLovBean lov) throws TCException {
		TCComponent[] comps = rev.whereUsed((short) 0);
		if (comps == null || comps.length == 0) {
			return;
		}
		for (TCComponent comp : comps) {
			CustomLovBean sub = new CustomLovBean(comp.getProperty("object_string"));
			System.out.println(sub.displayName);
			lov.addSub(sub);
			getTreeData(comp, sub);
		}
	}

	private void clearTable(JTable table, JCheckBox selectAll) {
		DefaultTableModel model = (DefaultTableModel) table.getModel();
		int cnt = model.getRowCount();
		for (int i = 0; i < cnt; i++) {
			model.removeRow(0);
		}
		table.revalidate();
		table.repaint();
		if (selectAll != null) {
			selectAll.setSelected(false);
		}
		try {
			closeWin();
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private JTree createTree(CustomLovBean lovData) {
		if (lovData == null || "".equals(lovData.displayName)) {
			return new JTree();
		}
		DefaultMutableTreeNode root = new DefaultMutableTreeNode(lovData.displayName);
		DefaultMutableTreeNode parent = root;
		DefaultTreeModel treeModel = new DefaultTreeModel(root);

		initTree(lovData, parent, treeModel);

		JTree tree = new JTree(treeModel);
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		DefaultTreeCellRenderer cellRenderer = (DefaultTreeCellRenderer) tree.getCellRenderer();
		cellRenderer.setTextNonSelectionColor(Color.black);
		cellRenderer.setTextSelectionColor(Color.blue);
		return tree;
	}

	private void initTree(CustomLovBean lovData, DefaultMutableTreeNode parent, DefaultTreeModel treeModel) {
		if (!lovData.hasChild()) {
			return;
		}
		List<CustomLovBean> subList = lovData.getSub();
		for (CustomLovBean sub : subList) {
			DefaultMutableTreeNode temp = new DefaultMutableTreeNode(sub.displayName);
			treeModel.insertNodeInto(temp, parent, parent.getChildCount());
			initTree(sub, temp, treeModel);
		}
	}

	private ItemListener selectAll(JTable table) {
		return new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent e) {
				// TODO Auto-generated method stub
				boolean select = ((JCheckBox) e.getSource()).isSelected();
				for (int i = 0; i < table.getRowCount(); i++) {
					JCheckBox checkBox = (JCheckBox) table.getValueAt(i, 0);
					checkBox.setSelected(select);
					table.revalidate();
					table.repaint();
				}
			}
		};
	}

	private ActionListener cancel() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				$this.dispose();
			}
		};
	}

	private ActionListener batchRevise(JTable table, JCheckBox selectAll) {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub

//				TCComponentTaskTemplate taskTemplate = null;
//				TCComponentProcessType processType = null;
//				try {
//					TCComponentTaskTemplateType taskTemplateType = (TCComponentTaskTemplateType) session
//							.getTypeComponent("EPMTaskTemplate");
//					taskTemplate = taskTemplateType.find("TCM Release Process", 0);
//					processType = (TCComponentProcessType) session.getTypeComponent("EPMJob");
//				} catch (TCException e2) {
//					// TODO Auto-generated catch block
//					e2.printStackTrace();
//					return;
//				}
				List<BOMManageTableBean> selectedRowList = getselectedRow(table);
				if (selectedRowList.size() == 0) {
					return;
				}
				if (!checkAccess(selectedRowList).isRes()) {
					return;
				}
				List<String[]> msgData = new ArrayList<String[]>();
				for (BOMManageTableBean bean : selectedRowList) {
					try {
						TCComponentItemRevision newRev = bean.getParentRev().saveAs(null);
//							TCComponentProcess localTCComponentProcess = (TCComponentProcess) processType.create(
//									newRev.getProperty("object_string"), "", taskTemplate, new TCComponent[] { newRev },
//									new int[] { 1 });
						msgData.add(new String[] { msgData.size() + 1 + "", bean.getParentString(),
								newRev.getProperty("object_string"), "ɹ" });
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
						JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
						return;
					}
				}

				JScrollPane jsp = DialogUtil.createTableMsg(new String[] { "", "汾(ǰ)", "汾()", "" },
						msgData).panel;
				JOptionPane.showMessageDialog($this, jsp, "", JOptionPane.PLAIN_MESSAGE);
				showWhereUesd(table, selectAll);
			}
		};
	}

	private Map<String, TCComponent> removeDuplicates(TCComponent[] comps) throws TCException {
		Map<String, TCComponent> sameParentUsedMap = new HashMap<String, TCComponent>();
		for (TCComponent comp : comps) {
			String itemId;
			if (sameParentUsedMap.containsKey(itemId = comp.getProperty("item_id"))) {
				if (sameParentUsedMap.get(itemId).getProperty("item_revision_id")
						.compareTo(comp.getProperty("item_revision_id")) < 0) {
					sameParentUsedMap.put(itemId, comp);
				}
			} else {
				sameParentUsedMap.put(itemId, comp);
			}
		}
		return sameParentUsedMap;
	}

	private void createLogDataSourceTable() {
		if (isLogcreated) {
			return;
		}
		String sql1 = "CREATE TABLE JD2_BOMManageLog ( id NUMBER ( 38, 0 ) primary key, modify_user VARCHAR2 ( 200 ), modify_time DATE, modify_content VARCHAR2 ( 500 ) )";
		String sql2 = "CREATE sequence JD2_BOMManageLog_seq minvalue 1 maxvalue 99999999 INCREMENT BY 1 START WITH 1";
		String sql3 = "CREATE OR REPLACE TRIGGER JD2_BOMManageLog_tri before INSERT ON JD2_BOMManageLog FOR each ROW BEGIN SELECT JD2_BOMManageLog_seq.nextval INTO : new.id FROM dual; END;";
		try {
			List<Entity> temp = null;
			temp = Db.use(DBUtil.getDataSource(session)).findBy("user_tables",
					new Condition("table_name", "JD2_BOMMANAGELOG"));
			if (temp == null || temp.size() == 0) {
				Db.use(DBUtil.getDataSource(session)).execute(sql1);
				System.out.println("JD2_BOMMANAGELOG create success");
			}
			temp = null;
			temp = Db.use(DBUtil.getDataSource(session)).findBy("user_sequences",
					new Condition("sequence_name", "JD2_BOMMANAGELOG_SEQ"));
			if (temp == null || temp.size() == 0) {
				Db.use(DBUtil.getDataSource(session)).execute(sql2);
				System.out.println("JD2_BOMMANAGELOG_SEQ create success");
			}
			temp = null;
			temp = Db.use(DBUtil.getDataSource(session)).findBy("all_triggers",
					new Condition("trigger_name", "JD2_BOMMANAGELOG_TRI"));
			if (temp == null || temp.size() == 0) {
				DBConnectionUtil.dbConn(session).createStatement().execute(sql3);
				System.out.println("JD2_BOMManageLog_tri create success");
			}
			isLogcreated = true;
			System.out.println("init log success");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			JOptionPane.showMessageDialog($this, "ݿʧܣѡjd2_db_settings", "", JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
		}
	}

	private ActionListener searchLog() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String username = ((JTextField) uiMap.get("p5UserText")).getText().trim();
				String content = ((JTextArea) uiMap.get("p5ContentText")).getText();
				JTable table = (JTable) uiMap.get("p5Table");
				clearTable(table, null);
				if (username == null || "".equals(username)) {
					return;
				}

				String sql = "select * from JD2_BOMMANAGELOG where ";
				if (!"*".equals(username)) {
					sql += "modify_user like '%" + username + "%' and";
				}
				sql += " modify_time between to_date('" + ((DatePicker) uiMap.get("p5timeStartText")).getText()
						+ " 00:00:00','yyyy-MM-dd hh24:mi:ss') and to_date('"
						+ ((DatePicker) uiMap.get("p5timeEndText")).getText() + " 23:59:59','yyyy-MM-dd hh24:mi:ss')";
				if (content != null && !"".equals(content)) {
					sql += " and modify_content like '%" + content + "%'";
				}
				sql += "order by MODIFY_TIME asc";
				System.out.println(sql);
				try {
					logDataList = Db.use(DBUtil.getDataSource(session)).query(sql);
					System.out.println("log size=====>" + logDataList.size());
					DefaultTableModel model = (DefaultTableModel) table.getModel();
					for (Entity entity : logDataList) {
						Object[] objArr = new Object[] { entity.get("ID"), entity.get("MODIFY_USER"),
								entity.get("MODIFY_TIME"), entity.get("MODIFY_CONTENT") };
						model.addRow(objArr);
					}
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					return;
				}
				table.revalidate();
				table.repaint();
			}
		};
	}

	private ActionListener downloadLog(JTable table) {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				if (table.getRowCount() > 0) {
					JFileChooser chooser = new JFileChooser();
					chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					chooser.setMultiSelectionEnabled(false);
					chooser.setCurrentDirectory(FileSystemView.getFileSystemView().getHomeDirectory());
					chooser.showOpenDialog($this);
					File folder = chooser.getSelectedFile();
					FileWriter fileWriter = null;
					String fileName = "BOM־-" + new SimpleDateFormat("yyyyMMddHHmm").format(new Date()) + ".txt";
					try {
						fileWriter = new FileWriter(folder.getPath() + File.separator + fileName);// ıļ
						String temp;
						System.out.println(logDataList.size());
						for (Entity entity : logDataList) {
							fileWriter.write((temp = entity.get("ID").toString())
									+ StringCreateUtil.createBlank(10 - temp.length())
									+ (temp = entity.get("MODIFY_USER").toString())
									+ StringCreateUtil.createBlank(20 - temp.length())
									+ (temp = entity.get("MODIFY_TIME").toString())
									+ StringCreateUtil.createBlank(30 - temp.length())
									+ entity.get("MODIFY_CONTENT").toString() + "\r\n");
						}
						fileWriter.flush();
						fileWriter.close();
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
						return;
					}

					JOptionPane.showMessageDialog($this, "־ɹ\r\n·" + folder + File.separator + fileName, "ʾ",
							JOptionPane.WARNING_MESSAGE);
				}
			}
		};

	}

	private ActionListener batchReplace() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String numStr = ((JTextField) uiMap.get("p1NumText")).getText().trim();
				KeyValComboBox combo = (KeyValComboBox) uiMap.get("p1UnitCombo");
				String text = combo.getSelectedText().trim();
				Object value = combo.getSelectedValue();
				System.out.println(numStr);
				if ("".equals(numStr) || "".equals(text) || targetRev2 == null) {
					JOptionPane.showMessageDialog($this, "δдϢд", "ʾ", JOptionPane.WARNING_MESSAGE);
					return;
				}
				List<BOMManageTableBean> selectedRowList = getselectedRow((JTable) uiMap.get("p1Table"));
				if (selectedRowList.size() == 0) {
					return;
				}
				if (!checkTargetAndSelect(targetRev, selectedRowList)) {
					return;
				}
				long startTime = System.currentTimeMillis();
				updateTitleShowProgress(selectedRowList);
				List<String[]> msgData = new ArrayList<String[]>();
				L1: for (BOMManageTableBean bean : selectedRowList) {
					try {
						doIndex++;
						System.out.println(value.toString());
						AIFComponentContext[] aifs = bean.getParentLine().getChildren();
						for (AIFComponentContext aif : aifs) {
							String objStr = ((TCComponentBOMLine) aif.getComponent()).getItemRevision()
									.getProperty("object_string");
							if (objStr.equals(targetRev2.getProperty("object_string"))) {
								continue L1;
							}
						}
						bean.getParentLine().remove("", bean.getChildLine());
						TCComponentBOMLine childLine = bean.getParentLine().add(targetRev2.getItem(), targetRev2, null,
								false, "");
						childLine.setReferenceProperty("bl_uom", (TCComponent) value);
						childLine.setProperties(new String[] { "bl_quantity" }, new String[] { numStr });
						msgData.add(
								new String[] { msgData.size() + 1 + "", bean.getParentString(), bean.getChildString(),
										targetRev2.getProperty("object_string"), value.toString(), numStr, "ɹ" });
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
						JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
						complate = true;
						return;
					}
				}
				try {
					saveWin();
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
					return;
				} finally {
					complate = true;
				}
				long endTime = System.currentTimeMillis();
				System.out.println("滻ִϣʱ" + (endTime - startTime) + "ms");
				doLog("batchReplace", msgData);
				JScrollPane jsp = DialogUtil
						.createTableMsg(new String[] { "", "", "ԭӼ", "滻Ӽ", "λ", "", "" }, msgData).panel;
				JOptionPane.showMessageDialog($this, jsp,
						"滻 ɹ(" + msgData.size() + ") ʱ" + (endTime - startTime) + "ms",
						JOptionPane.PLAIN_MESSAGE);
				removeSelectRow((JTable) uiMap.get("p1Table"));
				((JCheckBox) uiMap.get("p1SelectAll")).setSelected(false);
			}
		};
	}

	private ActionListener batchModify() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String numStr = ((JTextField) uiMap.get("p2NumText")).getText();
				List<BOMManageTableBean> selectedRowList = getselectedRow((JTable) uiMap.get("p2Table"));
				if (selectedRowList.size() == 0) {
					return;
				}
				if (!checkTargetAndSelect(targetRev, selectedRowList)) {
					return;
				}
				long startTime = System.currentTimeMillis();
				updateTitleShowProgress(selectedRowList);
				List<String[]> msgData = new ArrayList<String[]>();
				for (BOMManageTableBean bean : selectedRowList) {
					String oldNumStr = "";
					try {
						doIndex++;
						oldNumStr = bean.getChildLine().getProperty("bl_quantity");
						bean.getChildLine().setProperties(new String[] { "bl_quantity" }, new String[] { numStr });
						msgData.add(new String[] { msgData.size() + 1 + "", bean.getParentString(),
								bean.getChildString(), oldNumStr, numStr, "ɹ" });
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
						JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
						complate = true;
						return;
					}
				}
				try {
					saveWin();
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
					return;
				} finally {
					complate = true;
				}
				long endTime = System.currentTimeMillis();
				System.out.println("ִϣʱ" + (endTime - startTime) + "ms");
				doLog("batchModify", msgData);
				JScrollPane jsp = DialogUtil.createTableMsg(new String[] { "", "", "Ӽ", "ԭ", "", "" },
						msgData).panel;
				JOptionPane.showMessageDialog($this, jsp,
						"Ľ ɹ(" + msgData.size() + ") ʱ" + (endTime - startTime) + "ms",
						JOptionPane.PLAIN_MESSAGE);
//				((JTextField) uiMap.get("p2NumText")).setText("");
				showWhereUesd((JTable) uiMap.get("p2Table"), (JCheckBox) uiMap.get("p2SelectAll"));
			}
		};
	}

	private ActionListener batchAdd() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String numStr = ((JTextField) uiMap.get("p3NumText")).getText().trim();
				KeyValComboBox combo = (KeyValComboBox) uiMap.get("p3UnitCombo");
				String text = combo.getSelectedText().trim();
				Object value = combo.getSelectedValue();
				System.out.println(numStr);
				if ("".equals(numStr) || "".equals(text) || targetRev2 == null) {
					JOptionPane.showMessageDialog($this, "δдϢд", "ʾ", JOptionPane.WARNING_MESSAGE);
					return;
				}
				List<BOMManageTableBean> selectedRowList = getselectedRow((JTable) uiMap.get("p3Table"));
				if (selectedRowList.size() == 0) {
					return;
				}
				if (!checkTargetAndSelect(targetRev, selectedRowList)) {
					return;
				}
				long startTime = System.currentTimeMillis();
				updateTitleShowProgress(selectedRowList);
				List<String[]> msgData = new ArrayList<String[]>();
				L1: for (BOMManageTableBean bean : selectedRowList) {
					try {
						doIndex++;
						System.out.println(value.toString());
						AIFComponentContext[] aifs = bean.getParentLine().getChildren();
						for (AIFComponentContext aif : aifs) {
							String objStr = ((TCComponentBOMLine) aif.getComponent()).getItemRevision()
									.getProperty("object_string");
							if (objStr.equals(targetRev2.getProperty("object_string"))) {
								continue L1;
							}
						}
						TCComponentBOMLine childLine = bean.getParentLine().add(targetRev2.getItem(), targetRev2, null,
								false, "");
						childLine.setReferenceProperty("bl_uom", (TCComponent) value);
						childLine.setProperties(new String[] { "bl_quantity" }, new String[] { numStr });
						msgData.add(new String[] { msgData.size() + 1 + "", bean.getParentString(),
								targetRev2.getProperty("object_string"), value.toString(), numStr, "ɹ" });
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
						JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
						complate = true;
						return;
					}
				}
				try {
					saveWin();
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
					return;
				} finally {
					complate = true;
				}
				long endTime = System.currentTimeMillis();
				System.out.println("ִϣʱ" + (endTime - startTime) + "ms");
				doLog("batchAdd", msgData);
				JScrollPane jsp = DialogUtil.createTableMsg(new String[] { "", "", "Ӽ", "λ", "", "" },
						msgData).panel;
				JOptionPane.showMessageDialog($this, jsp,
						" ɹ(" + msgData.size() + ") ʱ" + (endTime - startTime) + "ms",
						JOptionPane.PLAIN_MESSAGE);
//				((JButton) uiMap.get("p3TargetBtn")).setText("");
//				((JButton) uiMap.get("p3AddBtn")).setText("");
//				((KeyValComboBox) uiMap.get("p3UnitCombo")).setSelectedIndex(0);
//				((JTextField) uiMap.get("p3NumText")).setText("");
				showWhereUesd((JTable) uiMap.get("p3Table"), (JCheckBox) uiMap.get("p3SelectAll"));
			}
		};
	}

	private ActionListener batchRemove() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				List<BOMManageTableBean> selectedRowList = getselectedRow((JTable) uiMap.get("p4Table"));
				if (selectedRowList.size() == 0) {
					return;
				}
				if (!checkTargetAndSelect(targetRev, selectedRowList)) {
					return;
				}
				long startTime = System.currentTimeMillis();
				updateTitleShowProgress(selectedRowList);
				List<String[]> msgData = new ArrayList<String[]>();
				for (BOMManageTableBean bean : selectedRowList) {
					try {
						doIndex++;
						bean.getParentLine().remove("", bean.getChildLine());
						msgData.add(new String[] { msgData.size() + 1 + "", bean.getParentString(),
								bean.getChildString(), "ɹ" });
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
						JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
						complate = true;
						return;
					}
				}
				try {
					saveWin();
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					JOptionPane.showMessageDialog($this, e1.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
					return;
				} finally {
					complate = true;
				}
				long endTime = System.currentTimeMillis();
				System.out.println("ɾִϣʱ" + (endTime - startTime) + "ms");
				doLog("batchRemove", msgData);
				JScrollPane jsp = DialogUtil.createTableMsg(new String[] { "", "", "ɾӼ", "" }, msgData).panel;
				JOptionPane.showMessageDialog($this, jsp,
						"ɾ ɹ(" + msgData.size() + ") ʱ" + (endTime - startTime) + "ms",
						JOptionPane.PLAIN_MESSAGE);
//				((JButton) uiMap.get("p4TargetBtn")).setText("");
//				clearTable((JTable) uiMap.get("p4Table"), (JCheckBox) uiMap.get("p4SelectAll"));
				removeSelectRow((JTable) uiMap.get("p4Table"));
				((JCheckBox) uiMap.get("p4SelectAll")).setSelected(false);
			}
		};
	}

	private List<BOMManageTableBean> getselectedRow(JTable table) {
		List<BOMManageTableBean> selectedList = new ArrayList<BOMManageTableBean>();
		for (int i = 0; i < table.getRowCount(); i++) {
			JCheckBox select = (JCheckBox) table.getValueAt(i, 0);
			if (select.isSelected()) {
				System.out.println("select=====>" + table.getValueAt(i, 1));
				selectedList.add(tableDataMap.get(table.getValueAt(i, 1)));
			}
		}
		return selectedList;
	}

	private void removeSelectRow(JTable table) {
		DefaultTableModel model = (DefaultTableModel) table.getModel();
		int i = 0;
		while (i < table.getRowCount()) {
			JCheckBox select = (JCheckBox) table.getValueAt(i, 0);
			if (select.isSelected()) {
				model.removeRow(i);
				continue;
			}
			i++;
		}
		table.revalidate();
		table.repaint();
	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		try {
			closeWin();
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		super.dispose();
	}

	private void saveWin() throws TCException {
		for (Entry<String, TCComponentBOMWindow> entry : winMap.entrySet()) {
			if (entry.getValue() != null) {
				entry.getValue().save();
			}

		}
	}

	private void closeWin() throws TCException {
		saveWin();

		for (Entry<String, TCComponentBOMWindow> entry : winMap.entrySet()) {
			entry.getValue().close();
		}
		winMap.clear();
	}

	private void doLog(String operation, List<String[]> msgData) {
		createLogDataSourceTable();
		String content = "";
		if ("batchReplace".equals(operation)) {
			content = "%sӼ%s滻Ϊ%s;%s;%s";
		} else if ("batchModify".equals(operation)) {
			content = "%sӼ%s%sΪ%s";
		} else if ("batchAdd".equals(operation)) {
			content = "%sӼ%s;%s;%s";
		} else if ("batchRemove".equals(operation)) {
			content = "%sɾӼ%s";
		}
		String username = "";
		try {
			username = session.getUser().getUserName() + "(" + session.getUser().getUserId() + ")";
		} catch (TCException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		String datetime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());

		List<String> sqls = new ArrayList<String>();
		int num = StrUtil.count(content, "%s");
		for (String[] arr : msgData) {
			String temp;
			String[] row = new String[num];
			for (int i = 0; i < num; i++) {
				row[i] = arr[i + 1];
			}
			temp = String.format(content, row);
			String sql = "insert into JD2_BOMMANAGELOG (MODIFY_USER,MODIFY_TIME,MODIFY_CONTENT) VALUES ('" + username
					+ "',to_date('" + datetime + "','yyyy-MM-dd hh24:mi:ss'),'" + temp + "')";
			sqls.add(sql);
		}

		try {
			Db.use(DBUtil.getDataSource(session)).executeBatch(sqls.toArray(new String[sqls.size()]));
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private ActionListener clickSearch(JTable table, JCheckBox selectAll) {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				JDialog content = DialogUtil.createSearchAndSelectRevDialog($this, table, selectAll,
						(JButton) e.getSource());
			}
		};
	}

	public void okCallback(JTable revTable, JTable table, JCheckBox selectAll, JButton field) {
		// TODO Auto-generated method stub
		int rowIndex = revTable.getSelectedRow();
		if (rowIndex < 0) {
			return;
		}
		String text = revTable.getValueAt(rowIndex, 0).toString();
		System.out.println(text);
		field.setText(text);
		if ("".equals(text)) {
			return;
		}
		if (table != null) {
			targetRev = (TCComponentItemRevision) revTable.getValueAt(rowIndex, 5);
			showWhereUesd(table, selectAll);
		} else {
			targetRev2 = (TCComponentItemRevision) revTable.getValueAt(rowIndex, 5);
		}
	}

	private KeyAdapter logSearchEnter() {
		return new KeyAdapter() {
			@Override
			public void keyTyped(KeyEvent e) {
				// TODO Auto-generated method stub
				super.keyTyped(e);
				if (e.getKeyChar() == KeyEvent.VK_ENTER) {
					((JButton) uiMap.get("p5Search")).doClick();
				}
			}
		};
	}

	private void updateTitleShowProgress(List<BOMManageTableBean> list) {
		new Thread(new Runnable() {

			@Override
			public void run() {
				int num = 1;
				String temp;
				doIndex = 0;
				while (!complate) {
					$this.setTitle("ڴ" + (temp = StringCreateUtil.createPoint(num % 3))
							+ StringCreateUtil.createBlank(5 - temp.length()) + list.get(doIndex).getParentString()
							+ "     " + (doIndex + 1) + "/" + list.size());
					try {
						Thread.sleep(200);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
					num++;
				}
				$this.setTitle("BOM");
				doIndex = -1;
				complate = false;
			}
		}).start();
	}

	private boolean checkReleaseStatus(TCComponentItemRevision rev) {
		try {
			System.out.println("item type======>" + rev.getItem().getType());
			if (checkItemType.contains(rev.getItem().getType())) {
				return true;
			}
			TCComponent form = rev.getRelatedComponents("IMAN_master_form_rev")[0];
			TCComponent[] statusArray = form.getRelatedComponents("release_status_list");
			String status = "";
			if (statusArray != null && statusArray.length > 0) {
				status = statusArray[statusArray.length - 1].getProperty("object_name");
			}
			if ("".equals(status) || "JD2_DJJY".equals(status) || "JD2_DJKY".equals(status)) {
				return false;
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return true;
	}

	private ResultData checkAccess(List<BOMManageTableBean> data) {
		for (BOMManageTableBean bean : data) {
			boolean isAccess = true;
			try {
				isAccess = session.getTCAccessControlService().checkPrivilege(bean.getParentLine(), "WRITE");
			} catch (TCException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (!isAccess) {
				try {
					return new ResultData(false, "ǰûûж" + bean.getParentLine().getProperty("object_string") + "дȨ",
							bean.getParentLine());
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
		return new ResultData(true, "", null);
	}

	private boolean checkTargetAndSelect(TCComponentItemRevision rev, List<BOMManageTableBean> data) {
		if (!checkReleaseStatus(rev)) {
			JOptionPane.showMessageDialog($this, "Ŀδߴڶ״̬޷BOM", "ʾ", JOptionPane.WARNING_MESSAGE);
			return false;
		}
		ResultData res = checkAccess(data);
		if (!res.isRes()) {
			JOptionPane.showMessageDialog($this, res.getMessage(), "ʾ", JOptionPane.WARNING_MESSAGE);
			return false;
		}
		return true;
	}
}
