package com.connor.jd.plm.dialogs;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.plaf.ColorUIResource;
import javax.swing.tree.TreeCellRenderer;

import com.connor.jd.plm.beans.TransformBomBean;
import com.teamcenter.rac.kernel.TCException;

public class CheckBoxTreeCellRenderer extends JPanel implements TreeCellRenderer {
	protected JCheckBox check;
	protected CheckBoxTreeLabel label;

	public CheckBoxTreeCellRenderer() {
		setLayout(null);
		add(check = new JCheckBox());
		add(label = new CheckBoxTreeLabel());
		// òɱ༭
		check.setEnabled(false);
		check.setBackground(UIManager.getColor("Tree.textBackground"));
		label.setForeground(UIManager.getColor("Tree.textForeground"));
	}

	/**
	 * صһ<code>JPanel</code>󣬸öаһ<code>JCheckBox</code>
	 * һ<code>JLabel</code>󡣲ҸÿǷѡ<code>JCheckBox</code> ǷѡС
	 */
	@Override
	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded,
			boolean leaf, int row, boolean hasFocus) {
		String stringValue = tree.convertValueToText(value, selected, expanded, leaf, row, hasFocus);
		setEnabled(tree.isEnabled());
		check.setSelected(((CheckBoxTreeNode) value).isSelected());
		label.setFont(tree.getFont());
		label.setText(stringValue);
		label.setSelected(selected);
		label.setFocus(hasFocus);

		CheckBoxTreeNode node = (CheckBoxTreeNode) value;
		TransformBomBean bean = (TransformBomBean) node.getUserObject();
		try {
			String type = bean.line.getItemRevision().getType();
			if (type.equals("WX3_ZPTRevision")) {
				URL resource = CheckBoxTreeCellRenderer.class.getResource("/com/connor/wxplm/utils/WX3_zptrev.png");
				label.setIcon(new ImageIcon(resource));
			} else if (type.equals("WX3_LJTRevision")) {
				URL resource = CheckBoxTreeCellRenderer.class.getResource("/com/connor/wxplm/utils/WX3_ljtrev.png");
				label.setIcon(new ImageIcon(resource));
			} else if (type.equals("WX3_WLRevision")) {
				URL resource = CheckBoxTreeCellRenderer.class.getResource("/com/connor/wxplm/utils/WX3_WLRev.png");
				label.setIcon(new ImageIcon(resource));
			}

		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*
		 * if(leaf) label.setIcon(UIManager.getIcon("Tree.leafIcon")); else if(expanded)
		 * label.setIcon(UIManager.getIcon("Tree.expandedIcon")); else
		 * label.setIcon(UIManager.getIcon("Tree.closedIcon"));
		 */

		return this;
	}

	@Override
	public Dimension getPreferredSize() {
		Dimension dCheck = check.getPreferredSize();
		Dimension dLabel = label.getPreferredSize();
		return new Dimension(dCheck.width + dLabel.width,
				dCheck.height < dLabel.height ? dLabel.height : dCheck.height);
	}

	@Override
	public void doLayout() {
		Dimension dCheck = check.getPreferredSize();
		Dimension dLabel = label.getPreferredSize();
		int yCheck = 0;
		int yLabel = 0;
		if (dCheck.height < dLabel.height)
			yCheck = (dLabel.height - dCheck.height) / 2;
		else
			yLabel = (dCheck.height - dLabel.height) / 2;
		check.setLocation(0, yCheck);
		check.setBounds(0, yCheck, dCheck.width, dCheck.height);
		label.setLocation(dCheck.width, yLabel);
		label.setBounds(dCheck.width, yLabel, dLabel.width, dLabel.height);
	}

	@Override
	public void setBackground(Color color) {
		if (color instanceof ColorUIResource)
			color = null;
		super.setBackground(color);
	}

}
