package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.ScrollPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

import com.connor.jd.plm.table.CTMap;
import com.connor.jd.plm.table.CTable;
import com.connor.jd.plm.table.MyCellEditor4;
import com.connor.jd.plm.table.TCTableUtil;
import com.connor.jd.plm.utils.DBUtil;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

import cn.hutool.db.Db;
import cn.hutool.db.Entity;

public class ComponentTestFrame extends JFrame {
	private CTMap model;
	private CTable table;
	private List<Entity> list;
	private int bottom;
	private Container container;
	private TCComponentForm form;
	private TCSession session;
	private MyCallBack callBack;

	private static ComponentTestFrame instance;

	public static ComponentTestFrame getInstance(TCComponentForm form, MyCallBack callBack) {
		if (instance == null) {
			instance = new ComponentTestFrame(form);
			instance.callBack = callBack;
		} else {
			instance.bottom = 0;
			instance.form = form;
			instance.callBack = callBack;
			instance.init();
		}
		return instance;
	}

	private ComponentTestFrame(TCComponentForm form) {
		this.form = form;
		this.session = (TCSession) AIFUtility.getCurrentApplication().getSession();
		this.init();
	}

	private void init() {
		this.setTitle("Ŀ");
		this.setSize(560, 400);
		this.setResizable(true);
		this.setAlwaysOnTop(true);
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		container = this.getContentPane();
		container.setLayout(new BorderLayout());
		container.setPreferredSize(new Dimension(600, 400));

		model = new CTMap(10, 7);
		model.setValueAt("", 0, 0);
		model.setValueAt("Ʒ", 0, 1);
		model.setValueAt("Ŀ", 0, 2);
		model.setValueAt("ʱ", 0, 3);
		model.setValueAt("Ʒ", 0, 4);
		model.setValueAt("", 0, 5);
		model.setValueAt("Ƿѡ", 0, 6);

		table = new CTable(model) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (row == 0 || col == 0) {
					return false;
				}
				return true;
			}
		};
		table.setRowHeight(25);
		table.setBorder(BorderFactory.createLineBorder(Color.black));
		for (int i = 0; i < model.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setPreferredWidth(80);
		}
		DefaultTableCellRenderer tcr1 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub

				if (value instanceof JCheckBox) {
					return (JCheckBox) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr1.setHorizontalAlignment(SwingConstants.CENTER);
		table.setDefaultRenderer(Object.class, tcr1);
		table.getColumnModel().getColumn(6).setCellEditor(new MyCellEditor4(new JTextField()));

		// д
		try {
			list = Db.use(DBUtil.getDataSource(session)).findAll("JD2_COMPONENT");
			bottom = list.size();
			for (int i = 0; i < bottom; i++) {
				if (i > model.getRowCount() - 2) {
					model.addRow();
				}
				int row = i + 1;
				model.setValueAt(row, row, 0);
				model.setValueAt(list.get(i).getStr("TEST_TYPE"), row, 1);
				model.setValueAt(list.get(i).getStr("TEST_PROJECT"), row, 2);
				model.setValueAt(list.get(i).getStr("TEST_TIME"), row, 3);
				model.setValueAt(list.get(i).getInt("TEST_NUM"), row, 4);
				model.setValueAt(list.get(i).getInt("TEST_COST"), row, 5);
				model.setValueAt(new JCheckBox(), row, 6);

				System.out.println(list.get(i).toString());
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			MessageBox.post("ݿô", "", MessageBox.ERROR);
			e.printStackTrace();
			return;
		}

		// ť
		JPanel buttonPanel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		JButton createTest = new JButton("Լƻ");
		createTest.addActionListener(createTest());
		JButton addTestItem = new JButton("");
		addTestItem.addActionListener(addTestItem());
		JButton cancel = new JButton("ȡ");
		cancel.addActionListener(cancel());
		buttonPanel.add(createTest);
		buttonPanel.add(addTestItem);
		buttonPanel.add(cancel);

		ScrollPane scrollPane = new ScrollPane();
		scrollPane.add(table);

		container.add(scrollPane, BorderLayout.CENTER);
		container.add(buttonPanel, BorderLayout.SOUTH);

		this.setVisible(true);
	}

	private ActionListener createTest() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				try {
					TCComponentItemRevision rev = (TCComponentItemRevision) form.whereReferenced()[0].getComponent();

					TCComponentItemType type = (TCComponentItemType) session.getTypeComponent("Item");
					TCComponentItem item = type.create(null, null, "JD2_GTCSJH", "Լƻ", "", null);
					rev.add("JD2_CSJH", item);
					TCComponentItemRevision rev1 = item.getLatestItemRevision();
					TCComponentForm form1 = (TCComponentForm) rev1.getRelatedComponents("IMAN_master_form_rev")[0];
					String[] colNames = new String[] { "jd2_no", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syzq",
							"jd2_syfy", "jd2_sycs" };
					List<String[]> list = new ArrayList<String[]>();
					String[] row = new String[7];
					for (int i = 1; i <= bottom; i++) {
						JCheckBox jb = (JCheckBox) model.getValueAt(i, 6);
						if (jb.isSelected()) {
							for (int ii = 2; ii < 6; ii++) {
								row[ii - 2] = model.getValueAt(i, ii) == null ? "" : model.getValueAt(i, ii).toString();
							}
//							TCComponentPerson p = (TCComponentPerson) session.getUser().getUserInformation().get(0);
							list.add(new String[] { i + "", form.getTCProperty("owning_user").getUIFValue(), row[0],
									row[2], row[1], row[3], "1" });
						}
					}
					String[][] data = list.toArray(new String[list.size()][7]);
					TCTableUtil.setTableRows(form1, "jd2_csjh", "JD2_CSJHTABLE", colNames, data);
					callBack.execute(item.getProperty("item_id"));
					dispose();
				} catch (TCException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		};
	}

	private ActionListener addTestItem() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				if (bottom > model.getRowCount() - 2) {
					model.addRow();
				}
				int num = 1;
				if (bottom > 0) {
					num = Integer.parseInt(model.getValueAt(bottom, 0).toString());
				}
				model.setValueAt(num + 1, ++bottom, 0);
				model.setValueAt(new JCheckBox(), bottom, 6);
			}
		};
	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		container.removeAll();
		super.dispose();
	}

	private ActionListener cancel() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				dispose();
			}
		};
	}

}
