package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import com.connor.jd.plm.beans.JG;
import com.connor.jd.plm.table.DatePickerCellEditor;
import com.connor.jd.plm.table.TCTableUtil;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.stylesheet.AbstractRendering;
import com.teamcenter.rac.util.MessageBox;

public class GTCSJHForm extends AbstractRendering {
	private TCComponentForm form;
	private Map<String, String> parentProp;
	private String[] labelNames = { "ĿϢ", "ʱ䣺", "ͺţ", "ͺţ", "Ʒͺţ", "Ŀϣ", "Ʒ", "Ʒ㣺", "Ʒʾ",
			"ճ̣", "ȼ", "׶Σ" };
	private String[] labellTexts = { "jd2_xmxx", "jd2_lxsj", "jd2_jbxh", "jd2_csxh", "jd2_cpxh", "jd2_xmzl", "jd2_cpjl",
			"jd2_cpbgd", "jd2_pzjl", "jd2_kfrc", "jd2_kfdj", "jd2_kfjd" };
	private String[] colNames = { "jd2_no", "jd2_syxh", "jd2_symd", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syzq",
			"jd2_syfy", "jd2_jhrc", "jd2_jhrc1", "jd2_sjrc", "jd2_sjrc1", "jd2_syzt", "jd2_syjg", "jd2_sycs",
			"jd2_syry", "jd2_csbg", "jd2_bz" };
	private String[] colDisplayNames = new String[] { "realNo", "NO", "ͺ", "Ŀ", "ίԱ", "Ŀ", "̨", "",
			"", "ƻʼճ", "ƻճ", "ʵʿʼճ", "ʵճ", "״̬", "ʵ", "_", "ʵԱ", "Ա", "ע" };
	private List<Integer> disableRows = new ArrayList<Integer>();
	private List<Integer> disableColumns = Arrays.asList(4, 5, 6, 8, 15, 17);// ίԱ, Ŀ, ̨,_,Ա
	private Map<String, JG> resultMap = new HashMap<String, JG>();
	private JTable table;
	private DefaultTableModel model;
	private TCComponentItemRevision rev;
	private TCSession session;
	private JLabel cost;
	private JLabel jg;
	private boolean againAllow = false;

	public GTCSJHForm(TCComponent arg0) throws Exception {
		super(arg0);
		if (arg0 instanceof TCComponentForm) {
			this.form = (TCComponentForm) arg0;
			this.session = (TCSession) AIFUtility.getCurrentApplication().getSession();
			loadRendering();
		}
	}

	@Override
	public void loadRendering() throws TCException {

		AIFComponentContext[] contexts = form.whereReferenced();
		for (int i = 0; i < contexts.length; i++) {
			if (contexts[i].getComponent() instanceof TCComponentItemRevision) {
				try {
					rev = (TCComponentItemRevision) contexts[i].getComponent();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		}

		// TODO Auto-generated method stub
		this.setLayout(new BorderLayout());
		JPanel root = new JPanel(new BorderLayout());
		JPanel top = new JPanel(new FlowLayout(FlowLayout.CENTER));
		JPanel inner = new JPanel();
		JPanel innerTop = new JPanel();
		JPanel innerCenter = new JPanel(new BorderLayout());
		root.setPreferredSize(new Dimension(1000, 500));
		inner.setLayout(null);
		inner.setPreferredSize(new Dimension(1000, 420));
		innerTop.setLayout(null);
		innerTop.setPreferredSize(new Dimension(880, 100));
		innerTop.setBorder(BorderFactory.createLineBorder(Color.black));
		innerTop.setBounds(10, 0, 880, 100);
		innerCenter.setPreferredSize(new Dimension(880, 300));
		innerCenter.setBorder(BorderFactory.createLineBorder(Color.black));
		innerCenter.setBounds(10, 120, 880, 300);

		JLabel title = new JLabel();
		AIFComponentContext[] aif = form.whereReferenced();
		for (AIFComponentContext a : aif) {
			if ("JD2_GTXPXMCSJHRevision".equals(a.getComponent().getType())) {
				try {
					title.setText(a.getComponent().getProperty("object_name"));
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				break;
			}
		}

		title.setFont(new Font("", Font.PLAIN, 24));
		top.add(title);

		JLabel[] infoText = new JLabel[13];
		JLabel[] infoValue = new JLabel[12];

		infoText[0] = new JLabel("Ϣ");
		infoText[0].setBounds(10, 0, 80, 25);

		for (int i = 1; i < 13; i++) {
			infoText[i] = new JLabel(labelNames[i - 1]);
//			infoValue[i - 1] = new JLabel(labellTexts[i - 1]);
			infoValue[i - 1] = new JLabel();
		}
		for (int i = 1; i < 7; i++) {
			infoText[i].setBounds(25 * i + 120 * (i - 1), 30, 60, 25);
			infoValue[i - 1].setBounds(85 * i + 60 * (i - 1), 30, 60, 25);
			infoText[i + 6].setBounds(25 * i + 120 * (i - 1), 60, 60, 25);
			infoValue[i + 5].setBounds(85 * i + 60 * (i - 1), 60, 60, 25);
		}
		innerTop.add(infoText[0]);
		for (int i = 0; i < 12; i++) {
			innerTop.add(infoText[i + 1]);
			innerTop.add(infoValue[i]);
		}

		model = new DefaultTableModel(colDisplayNames, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				// TODO Auto-generated method stub
				if (disableRows.contains(paramInt1) || disableColumns.contains(paramInt2)) {
					return false;
				}
				return true;
			}
		};
		JComboBox<String> status = new JComboBox<String>();
		status.addItem("");
		status.addItem("");
		status.addItem("");
		status.addItem(" ");
		DefaultCellEditor dce1 = new DefaultCellEditor(status) {
			int row;

			@Override
			public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row,
					int column) {
				this.row = row;
				return super.getTableCellEditorComponent(table, value, isSelected, row, column);
			}

			@Override
			public Object getCellEditorValue() {
				Object obj = super.getCellEditorValue();
				if ("".equals(obj == null ? "" : obj.toString())) {
//					disableRows.add(row);
				}
				return obj;
			}
		};
		JComboBox<String> result = new JComboBox<String>();
		result.addItem("ϸ");
		result.addItem("ϸ");
		result.addItem(" ");
		DefaultCellEditor dce2 = new DefaultCellEditor(result) {
			JTable table;
			int row;

			@Override
			public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row,
					int column) {
				this.table = table;
				this.row = row;
				return super.getTableCellEditorComponent(table, value, isSelected, row, column);
			}

			@Override
			public Object getCellEditorValue() {
				Object obj = super.getCellEditorValue();
				String res = (obj == null ? "" : obj.toString());
				String no = table.getValueAt(row, 0).toString();
				Object temp;
				int times = Integer.parseInt((temp = table.getValueAt(row, 15)) == null ? "0" : temp.toString().trim());
				System.out.println("" + res);
				addResult(no, row, times, res);

				jg.setText(getResult());
				return obj;
			}
		};

		DatePickerCellEditor dpce = new DatePickerCellEditor(new JTextField());
		table = new JTable(model);
		for (int i = 1; i < table.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setMinWidth(100);
		}
		hiddenColumn(table, 0);
		DefaultCellEditor deafult = new DefaultCellEditor(new JTextField());
		for (int i = 0; i < table.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setCellEditor(deafult);
		}
		table.getColumnModel().getColumn(9).setCellEditor(dpce);
		table.getColumnModel().getColumn(10).setCellEditor(dpce);
		table.getColumnModel().getColumn(11).setCellEditor(dpce);
		table.getColumnModel().getColumn(12).setCellEditor(dpce);
		table.getColumnModel().getColumn(13).setCellEditor(dce1);
		table.getColumnModel().getColumn(14).setCellEditor(dce2);
		table.setRowHeight(25);
		table.setAutoscrolls(true);
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.getTableHeader().setReorderingAllowed(false);
//		table.putClientProperty("terminateEditOnFocusLost", true);// ʧȥԶύ(¼ؼtoday)
		table.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (table.getSelectedColumn() == 17) {
					if (e.getClickCount() == 2) {
						System.out.println("˫");
						int selectedRow = table.getSelectedRow(); // ѡ
						String value = (String) model.getValueAt(selectedRow, 17);
						if (value == null)
							value = "";
						if (!value.equals("")) {
							try {
								TCComponent[] result = session.search(" ID", new String[] { " ID" },
										new String[] { value });
								TCComponentItem item = (TCComponentItem) result[0];
								TCComponent[] tccitem = item.getLatestItemRevision().getTCProperty("IMAN_specification")
										.getReferenceValueArray();
								TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
								dataset.open();
							} catch (Exception e1) {
								e1.printStackTrace();
							}
						}
					}
				}

			}
		});
		JScrollPane jsp = new JScrollPane(table);
		innerCenter.add(jsp, BorderLayout.CENTER);

		JButton test = new JButton("<html>Ա<br>ϴ</html>");
		JButton collect = new JButton("<html>ܽ<br>ϴ</html>");
		JButton again = new JButton("ٴ");
		test.setBounds(900, 120, 100, 50);
		collect.setBounds(900, 175, 100, 50);
		again.setBounds(900, 230, 100, 25);
		test.addActionListener(test());
		collect.addActionListener(collect());
		again.addActionListener(again());
		inner.add(test);
		inner.add(collect);
		inner.add(again);

		JLabel label1 = new JLabel("ܼƣ");
		JLabel label2 = new JLabel("ۣ");
		cost = new JLabel();
		jg = new JLabel();
		label1.setBounds(300, 470, 120, 25);
		cost.setBounds(420, 470, 50, 25);
		label2.setBounds(480, 470, 50, 25);
		jg.setBounds(530, 470, 60, 25);
		root.add(label1);
		root.add(label2);
		root.add(cost);
		root.add(jg);

		// ȡϢ
		AIFComponentContext[] aifs = form.whereReferenced();
		String temp;
		for (AIFComponentContext a1 : aifs) {
			System.out.println("Խ۰汾" + (temp = a1.getComponent().getType()));
			if ("JD2_GTXPXMCSJHRevision".equals(temp)) {
				TCComponentItemRevision rev = (TCComponentItemRevision) a1.getComponent();
				AIFComponentContext[] aifs2 = rev.getItem().whereReferenced();
				for (AIFComponentContext a2 : aifs2) {
					System.out.println("ƷĿ嵥汾" + (temp = a2.getComponent().getType()));
					if ("JD2_GTXPCSXQDRevision".equals(temp)) {
						TCComponentItemRevision rev2 = (TCComponentItemRevision) a2.getComponent();
						TCComponentForm parent = (TCComponentForm) rev2.getRelatedComponents("IMAN_master_form_rev")[0];
						parentProp = parent.getProperties();
					}
				}
			}
		}
		if (parentProp != null) {
			for (int i = 0; i < labellTexts.length; i++) {
				if (parentProp.containsKey(labellTexts[i])) {
					String str = parentProp.get(labellTexts[i]);
					infoValue[i].setText(str);
				} else {
					System.out.println("\"" + labellTexts[i] + "\"");
				}
			}
		}

		String[][] data = TCTableUtil.getTableRows(form, "jd2_csjhtable", colNames);
		System.out.println(data[0].length);
		System.out.println(colNames.length);
		System.out.println(Arrays.deepToString(data));
		System.out.println(data.length);
		double sum = 0;
		for (int i = 0; i < data.length; i++) {
			String[] rowData = new String[19];
			rowData[0] = data[i][0];
			rowData[1] = i + 1 + "";
			for (int ii = 1; ii < colNames.length; ii++) {
				rowData[ii + 1] = data[i][ii];
			}
			model.addRow(rowData);

			if ("".equals(data[i][12])) {
//				disableRows.add(i);
			}
			sum += Double.parseDouble(data[i][7]);
			addResult(data[i][0], i, Integer.parseInt(data[i][14]), data[i][13]);
		}

		// ·
		TCComponentItem item = rev.getItem();
		TCComponentItemRevision[] revs = item.getReleasedItemRevisions();
		Comparator<TCComponent> leatestRevisionComparator = new Comparator<TCComponent>() {

			@Override
			public int compare(TCComponent o1, TCComponent o2) {
				// TODO Auto-generated method stub
				try {
					return o1.getProperty("item_revision_id").compareTo(o2.getProperty("item_revision_id"));
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return 0;
			}
		};
		Arrays.parallelSort(revs, leatestRevisionComparator);
		if (revs.length > 0) {
			List<Map<String, String>> dataMap = TCTableUtil.getTableMapList(
					(TCComponentForm) revs[revs.length - 1].getRelatedComponent("IMAN_master_form_rev"),
					"jd2_csjhtable", colNames);
			List<String> realNoList = new ArrayList<String>();
			for (Map<String, String> tempMap : dataMap) {
				realNoList.add(tempMap.get("jd2_no") + "," + tempMap.get("jd2_sycs"));
			}
			for (int i = 0; i < data.length; i++) {
				if (realNoList.contains(data[i][0] + "," + data[i][14])) {
					disableRows.add(i);
				}
			}
		}

		// Ŀǰ汾ǷΪ·һ汾
		List<String> releasedObjectString = new ArrayList<String>();
		for (int i = 0; i < revs.length; i++) {
			releasedObjectString.add(revs[i].getProperty("object_string"));
		}
		if (revs.length > 0) {
			if (!releasedObjectString.contains(rev.getProperty("object_string"))) {
				TCComponent[] allRev = item.getRelatedComponents("revision_list");
				Arrays.parallelSort(allRev, leatestRevisionComparator);
				for (int i = 0; i < allRev.length; i++) {
					if (allRev[i].getProperty("object_string")
							.equals(revs[revs.length - 1].getProperty("object_string")) && i + 1 < allRev.length) {
						if (rev.getProperty("object_string").equals(allRev[i + 1].getProperty("object_string"))) {
							againAllow = true;
							break;
						}
					}
				}
			}
		}

		table.revalidate();
		table.repaint();
		cost.setText(sum + "");
		jg.setText(getResult());

		inner.add(innerTop);
		inner.add(innerCenter);
		root.add(top, BorderLayout.NORTH);
		root.add(inner, BorderLayout.CENTER);
		JScrollPane jsp1 = new JScrollPane(root);
		this.add(jsp1, BorderLayout.CENTER);
	}

	@Override
	public void saveRendering() {
		// TODO Auto-generated method stub
		if (table.getSelectedColumn() >= 0) {
			table.getColumnModel().getColumn(table.getSelectedColumn()).getCellEditor().stopCellEditing();
		}
		String[][] data = new String[0][];
		List<String[]> dataList = new ArrayList<String[]>();
		Object obj;
		for (int i = 0; i < table.getRowCount(); i++) {
			String[] rowData = new String[colNames.length];
			for (int ii = 0; ii < colNames.length; ii++) {
				rowData[ii] = (obj = table.getValueAt(i, ii > 0 ? ii + 1 : ii)) == null ? "" : obj.toString();
			}
			dataList.add(rowData);
		}
		data = dataList.toArray(new String[dataList.size()][]);
		TCTableUtil.setTableRows(form, "jd2_csjhtable", "JD2_CSJHTABLE", colNames, data);
	}

	private ActionListener test() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				JFileChooser chooser = new JFileChooser();
				chooser.setDialogTitle("ѡϴĲԱ");
				FileFilter filter = new FileNameExtensionFilter("Excel(.xlsx,.xls,.xlsm)", "xlsx", "xls", "xlsm");
				chooser.setFileFilter(filter);
				chooser.showOpenDialog(null);
				File file = chooser.getSelectedFile();

				if (file != null) {
					String filePath = file.getPath();
					String fileName = file.getName();
					String filename = fileName.substring(0, fileName.lastIndexOf("."));
					System.out.println(filePath);
					System.out.println(fileName);
					int row = table.getSelectedRow();
					String value = model.getValueAt(row, 17) == null ? "" : model.getValueAt(row, 17).toString();
					if (value.equals("")) {
						try {
							TCComponentItemType itemtype = (TCComponentItemType) session.getTypeComponent("JD2_GTCSBG");
							String itemId = itemtype.getNewID();
							String itemRev = itemtype.getNewRev(null);
							TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName, "", null);
							rev.add("JD2_CSBG", item);
							TCComponentDatasetType datasetType = (TCComponentDatasetType) session
									.getTypeComponent("Dataset");
							String msType = "";
							if (filePath.endsWith(".xls")) {
								msType = "MSExcel";
							} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
								msType = "MSExcelX";
							}
							TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
							datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { "excel" });// Σļ·Ӧãtext
							item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
							model.setValueAt(item.getProperty("current_id"), row, 17);
						} catch (TCException e1) {
							e1.printStackTrace();
						}
					} else {
						// ӵݼ
						boolean exist = false;
						try {
							TCComponent[] tcc = rev.getTCProperty("JD2_CSBG").getReferenceValueArray();
							for (int i = 0; i < tcc.length; i++) {
								if (value.equals(tcc[i].getProperty("current_id"))) {
									exist = true;
									TCComponentItem item = (TCComponentItem) tcc[i];
									TCComponent[] tccitem = item.getLatestItemRevision()
											.getTCProperty("IMAN_specification").getReferenceValueArray();
									TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
									dataset.setFiles(new String[] { file.getPath() }, new String[] { "excel" });
									dataset.setProperty("object_name", filename);
									item.setProperty("object_name", filename);
									item.getLatestItemRevision().setProperty("object_name", filename);
								}
							}
							if (!exist) {
								try {
									TCComponentItemType itemtype = (TCComponentItemType) session
											.getTypeComponent("JD2_GTCSBG");
									String itemId = itemtype.getNewID();
									String itemRev = itemtype.getNewRev(null);
									TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName,
											"", null);
									rev.add("JD2_CSBG", item);
									TCComponentDatasetType datasetType = (TCComponentDatasetType) session
											.getTypeComponent("Dataset");
									String msType = "";
									if (filePath.endsWith(".xls")) {
										msType = "MSExcel";
									} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
										msType = "MSExcelX";
									}
									TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
									datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { "excel" });// Σļ·Ӧãtext
									item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
									model.setValueAt(item.getProperty("current_id"), row, 17);
								} catch (TCException e1) {
									e1.printStackTrace();
								}
							}
						} catch (TCException e1) {
							e1.printStackTrace();
						}
					}

				}
			}
		};
	}

	private ActionListener collect() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
//				int row = table.getSelectedRow();
//				String value = (String) model.getValueAt(row, 17);
				JFileChooser chooser = new JFileChooser();
				chooser.setDialogTitle("ѡϴĻܽ");
				FileFilter filter = new FileNameExtensionFilter("Excel(.xlsx,.xls,.xlsm),PPTʾĸ(.ppt,.pptx)",
						"xlsx", "xls", "xlsm", "ppt", "pptx");// ļֻгJPGGIFʽͼƬ
				chooser.setFileFilter(filter);
				chooser.showOpenDialog(null);
				File file = chooser.getSelectedFile();
				TCComponentItemRevision parentRev = null;
				try {
					AIFComponentContext[] aifs = rev.getItem().whereReferenced();
					for (AIFComponentContext aif : aifs) {
						if (aif.getComponent().getType().equals("JD2_GTXPCSXQDRevision")) {
							parentRev = (TCComponentItemRevision) aif.getComponent();
							break;
						}
					}
				} catch (TCException e2) {
					// TODO Auto-generated catch block
					e2.printStackTrace();
				}
				if (file != null && parentRev != null) {
					String filePath = file.getPath();
					String fileName = file.getName();
					String filename = fileName.substring(0, fileName.lastIndexOf("."));
					System.out.println(filePath);
					System.out.println(fileName);

//					if (value.equals("")) {
					try {
						TCComponentItemType itemtype = (TCComponentItemType) session.getTypeComponent("JD2_GTCSBG");
						String itemId = itemtype.getNewID();
						String itemRev = itemtype.getNewRev(null);
						TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName, "", null);
						parentRev.add("JD2_CSBGHZ", item);
						TCComponentDatasetType datasetType = (TCComponentDatasetType) session
								.getTypeComponent("Dataset");
						String msType = "";
						String fileType = "";
						if (filePath.endsWith(".xls")) {
							msType = "MSExcel";
							fileType = "excel";
						} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
							msType = "MSExcelX";
							fileType = "excel";
						} else if (filePath.endsWith(".ppt")) {
							msType = "MSPowerPoint";
							fileType = "powerpoint";
						} else if (filePath.endsWith(".pptx")) {
							msType = "MSPowerPointX";
							fileType = "powerpoint";
						}
						TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
						datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { fileType });// Σļ·Ӧãtext
						item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
						MessageBox.post("ϴɹ", "ʾ", MessageBox.WARNING);
					} catch (TCException e1) {
						e1.printStackTrace();
					}
//					} else {
//						// ӵݼ
//						boolean exist = false;
//						try {
//							TCComponent[] tcc = rev.getTCProperty("JD2_CSBGHZ").getReferenceValueArray();
//							for (int i = 0; i < tcc.length; i++) {
//								if (value.equals(tcc[i].getProperty("current_id"))) {
//									exist = true;
//									TCComponentItem item = (TCComponentItem) tcc[i];
//									TCComponent[] tccitem = item.getLatestItemRevision()
//											.getTCProperty("IMAN_specification").getReferenceValueArray();
//									TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
//									dataset.setFiles(new String[] { file.getPath() }, new String[] { "excel" });
//									dataset.setProperty("object_name", filename);
//									item.setProperty("object_name", filename);
//									item.getLatestItemRevision().setProperty("object_name", filename);
//								}
//							}
//							if (!exist) {
//								try {
//									TCComponentItemType itemtype = (TCComponentItemType) session
//											.getTypeComponent("JD2_GTCSBG");
//									String itemId = itemtype.getNewID();
//									String itemRev = itemtype.getNewRev(null);
//									TCComponentItem item = itemtype.create(itemId, itemRev, "JD2_GTCSBG", fileName,
//											"", null);
//									parentRev.add("JD2_CSBGHZ", item);
//									TCComponentDatasetType datasetType = (TCComponentDatasetType) session
//											.getTypeComponent("Dataset");
//									String msType = "";
//									if (filePath.endsWith(".xls")) {
//										msType = "MSExcel";
//									} else if (filePath.endsWith(".xlsx") || filePath.endsWith(".xlsm")) {
//										msType = "MSExcelX";
//									}
//									TCComponentDataset datasetMSExcelX = datasetType.create(filename, "", msType);
//									datasetMSExcelX.setFiles(new String[] { filePath }, new String[] { "excel" });// Σļ·Ӧãtext
//									item.getLatestItemRevision().add("IMAN_specification", datasetMSExcelX);
//								} catch (TCException e1) {
//									e1.printStackTrace();
//								}
//							}
//						} catch (TCException e1) {
//							e1.printStackTrace();
//						}
//
//					}
				}
			}
		};
	}

	private ActionListener again() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int row = table.getSelectedRow();
				Object obj;
				if (row != -1) {
					if (!againAllow) {
						MessageBox.post("ǰİ汾·汾һδ汾ٴ", "ʾ", MessageBox.WARNING);
						return;
					}
					String realNum = (obj = table.getValueAt(row, 0)) == null ? "0" : obj.toString();
					int num = Integer.parseInt((obj = table.getValueAt(row, 1)) == null ? "0" : obj.toString());
					String[] rowData = new String[table.getColumnCount()];
					rowData[0] = realNum;
					rowData[1] = num + 1 + "";
					num = Integer.parseInt((obj = table.getValueAt(row, 15)) == null ? "0" : obj.toString());
					boolean isNotLatest = false;
					String realNum1;
					int num1;
					for (int i = 0; i < table.getRowCount(); i++) {
						realNum1 = (obj = table.getValueAt(i, 0)) == null ? "0" : obj.toString();
						if (realNum.equals(realNum1)) {
							num1 = Integer.parseInt((obj = table.getValueAt(i, 15)) == null ? "0" : obj.toString());
							if (num < num1) {
								isNotLatest = true;
								break;
							}
						}
					}
					if (isNotLatest) {
						MessageBox.post("ѡµһʵ", "ʾ", MessageBox.WARNING);
						return;
					}
//					boolean allowFlag = false;
//					if (againAllowFlow == null) {
//						try {
//							againAllowFlow = JDMethodUtil.getPrefStrArray("jd_csjh_again_allow", session)[0];// 
//							TCComponent[] comps = form.getRelatedComponents("fnd0AllWorkflows");
//							if (comps.length > 0) {
//								String flowName;
//								for (TCComponent comp : comps) {
//									flowName = comps[0].getProperty("object_name");
//									System.out.println(flowName);
//									if (flowName.equals(againAllowFlow)) {
//										allowFlag = true;
//										break;
//									}
//								}
//							} else {
//								MessageBox.post("޷ٴ飬ȷϵǰĿ괦", "ʾ", MessageBox.WARNING);
//								return;
//							}
//						} catch (ArrayIndexOutOfBoundsException ex) {
//							// TODO: handle exception
//							ex.printStackTrace();
//							MessageBox.post("ѡ\"jd_csjh_again_allow\"ô", "", MessageBox.ERROR);
//							return;
//						} catch (TCException e1) {
//							// TODO Auto-generated catch block
//							e1.printStackTrace();
//						}
//					}
//					if (!allowFlag) {
//						MessageBox.post("޷ٴ飬Ŀ״̬\"jd_csjh_again_allow\"", "ʾ", MessageBox.WARNING);
//						return;
//					}
					for (int i = 2; i < 9; i++) {
						rowData[i] = (obj = table.getValueAt(row, i)) == null ? "" : obj.toString();
					}
					rowData[15] = num + 1 + "";
					rowData[16] = (obj = table.getValueAt(row, 16)) == null ? "" : obj.toString();
					disableRows.add(row);
					model.insertRow(row + 1, rowData);
					for (int i = 0; i < disableRows.size(); i++) {
						if (disableRows.get(i) >= (row + 1)) {
							disableRows.set(i, disableRows.get(i) + 1);
						}
					}
					for (Entry<String, JG> entry : resultMap.entrySet()) {
						if (entry.getValue().getRow() >= (row + 1)) {
							resultMap.get(entry.getKey()).setRow(entry.getValue().getRow() + 1);
						}
					}
					table.revalidate();
					table.repaint();

					cost.setText(getCost() + "");

				}

			}
		};
	}

	private void hiddenColumn(JTable table, int columnIndex) {
		TableColumnModel tcm = table.getColumnModel();
		TableColumn tc = tcm.getColumn(columnIndex);
		// tc.setResizable(false);
		tc.setWidth(0);
		tc.setPreferredWidth(0);
		tc.setMaxWidth(0);
		tc.setMinWidth(0);
		table.getTableHeader().getColumnModel().getColumn(columnIndex).setMaxWidth(0);
		table.getTableHeader().getColumnModel().getColumn(columnIndex).setMinWidth(0);
	}

	private double getCost() {
		double sum = 0;
		Object obj;
		for (int i = 0; i < table.getRowCount(); i++) {
			double num = Double.parseDouble((obj = table.getValueAt(i, 8)) == null ? "0" : obj.toString());
			sum += num;
		}
		return sum;
	}

	private void addResult(String realNo, int row, int times, String result) {
		if (resultMap.containsKey(realNo)) {
			if (times >= resultMap.get(realNo).getTimes()) {
				if (table.getSelectedRow() < 0) {
					disableRows.add(resultMap.get(realNo).getRow());// ʼʱֹдС
				}
				resultMap.put(realNo, new JG(row, times, result));
			}
		} else {
			resultMap.put(realNo, new JG(row, times, result));
		}
	}

	private String getResult() {
		boolean notEmpty = false;
		boolean qualified = true;
		for (Entry<String, JG> entry : resultMap.entrySet()) {
//			System.out.println("realNo:" + entry.getKey() + "row:" + entry.getValue().getRow() + "jg:"
//					+ entry.getValue().getJg() + "times:" + entry.getValue().getTimes());
			if (!"".equals(entry.getValue().getJg().trim())) {
				notEmpty = true;
			}
			if ("ϸ".equals(entry.getValue().getJg())) {
				qualified = false;
				break;
			}
		}

		return notEmpty ? (qualified ? "ϸ" : "ϸ") : "";
	}

	@Override
	public boolean isRenderingModified() {
		// TODO Auto-generated method stub
		return form.isCheckedOut();
	}
}
