package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

import com.connor.jd.plm.table.CTMap;
import com.connor.jd.plm.table.CTable;
import com.connor.jd.plm.table.JCheckPanel;
import com.connor.jd.plm.table.ModelList;
import com.connor.jd.plm.table.ModelValue;
import com.connor.jd.plm.table.MyCellEditor3;
import com.connor.jd.plm.table.TCTableUtil;
import com.connor.jd.plm.utils.DBUtil;
import com.connor.jd.plm.utils.DialogUtil;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentProject;
import com.teamcenter.rac.kernel.TCComponentSchedule;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.stylesheet.AbstractRendering;
import com.teamcenter.rac.util.MessageBox;

import cn.hutool.db.Db;
import cn.hutool.db.Entity;

public class NewProductTestForm extends AbstractRendering {
	private TCComponentForm form;
	private CTMap model1;
	private CTMap model2;
	private CTable table1;
	private CTable table2;
	private Map<String, String> prop;
	private ModelList modelList1;
	private ModelList modelList2;
	private List<Entity> dbData = new ArrayList<Entity>();
	private JPopupMenu menu = new JPopupMenu();
	private JMenuItem addR;
	private String[][] data = new String[0][];
	private String[] colNames = { "jd2_no", "jd2_lb", "jd2_xm", "jd2_xmfy", "jd2_DV", "jd2_PV", "jd2_PR", "jd2_SR",
			"jd2_bz" };
	private String[] colNames2 = { "jd2_no", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syfy", "jd2_sycs" };
	private String[] colNames3 = { "jd2_no", "jd2_syxh", "jd2_symd", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syzq",
			"jd2_syfy", "jd2_jhrc", "jd2_jhrc1", "jd2_sjrc", "jd2_sjrc1", "jd2_syzt", "jd2_syjg", "jd2_sycs",
			"jd2_syry", "jd2_csbg", "jd2_bz" };
	private String[] jieduan = { "DV", "PV", "PR", "SR" };
	private TCSession session;
	private List<String[]> compareDataList = new ArrayList<String[]>();
	private boolean testFlag = false;
	private List<String> realIdStr = new ArrayList<String>();
	private TCComponentProject project;
	private NewProductTestForm $this;

	public NewProductTestForm(TCComponent arg0) throws Exception {
		super(arg0);
		if (arg0 instanceof TCComponentForm) {
			this.form = (TCComponentForm) arg0;
			this.session = (TCSession) AIFUtility.getCurrentApplication().getSession();
			try {
				dbData = Db.use(DBUtil.getDataSource(session))
						.query("select * from JD2_Machine ORDER BY TEST_TYPE ASC");
			} catch (Exception e) {
				MessageBox.post("ݿô", "", MessageBox.ERROR);
				e.printStackTrace();
				return;
			}
			$this = this;
			loadRendering();
		}
	}

	@Override
	public void loadRendering() throws TCException {
		this.setLayout(new BorderLayout());
		JPanel root = new JPanel(new BorderLayout());
		root.setPreferredSize(new Dimension(800, 500));
		JPanel inner = new JPanel(new BorderLayout());

		JPanel top = new JPanel(new FlowLayout(FlowLayout.CENTER));
		JLabel title = new JLabel("ƷĿԵ");
		title.setFont(new Font("", Font.PLAIN, 24));
		top.add(title);
		inner.add(top, BorderLayout.NORTH);

		prop = form.getProperties();

		// ʼ
		model1 = new CTMap(6, 4);
		modelList1 = new ModelList();
		String[] textArr1 = { "ĿϢ", "ʱ䣺", "ͺţ", "ͺţ", "Ʒͺţ", "Ŀϣ", "Ʒ", "Ʒ㣺", "Ʒʾ", "ճ̣",
				"ȼ", "׶Σ" };
		int[][] textLocation1 = { { 0, 0 }, { 0, 2 }, { 1, 0 }, { 1, 2 }, { 2, 0 }, { 2, 2 }, { 3, 0 }, { 3, 2 },
				{ 4, 0 }, { 4, 2 }, { 5, 0 }, { 5, 2 } };
		for (int i = 0; i < textArr1.length; i++) {
			modelList1.add(new ModelValue(textArr1[i], false, textLocation1[i][0], textLocation1[i][1], false));
		}
		String[] propArr = { "jd2_xmxx", "jd2_lxsj", "jd2_jbxh", "jd2_csxh", "jd2_cpxh", "jd2_xmzl", "jd2_cpjl",
				"jd2_cpbgd", "jd2_pzjl", "jd2_kfrc", "jd2_kfdj", "jd2_kfjd" };
		int[][] propLocation1 = { { 0, 1 }, { 0, 3 }, { 1, 1 }, { 1, 3 }, { 2, 1 }, { 2, 3 }, { 3, 1 }, { 3, 3 },
				{ 4, 1 }, { 4, 3 }, { 5, 1 }, { 5, 3 } };
		for (int i = 0; i < propArr.length; i++) {
			modelList1.add(new ModelValue(propArr[i], true, propLocation1[i][0], propLocation1[i][1], true));
		}

		initModel(model1, modelList1);

		table1 = new CTable(model1) {
			@Override
			public boolean isCellEditable(int row, int col) {
				return !modelList1.isDisableEdit(row, col);
			}
		};

		table1.setRowHeight(25);
		table1.setBorder(BorderFactory.createLineBorder(Color.black));
		table1.getColumnModel().getColumn(0).setPreferredWidth(100);
		table1.getColumnModel().getColumn(1).setPreferredWidth(100);
		table1.getColumnModel().getColumn(2).setPreferredWidth(100);
		table1.getColumnModel().getColumn(3).setPreferredWidth(200);
		table1.putClientProperty("terminateEditOnFocusLost", true);

		DefaultTableCellRenderer tcr1 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub
				if (value instanceof JCheckPanel) {
					return (JCheckPanel) value;
				}

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};
		tcr1.setHorizontalAlignment(SwingConstants.CENTER);
		table1.setAutoResizeMode(CTable.AUTO_RESIZE_NEXT_COLUMN);
		table1.setDefaultRenderer(Object.class, tcr1);
		inner.add(table1, BorderLayout.CENTER);

		modelList2 = new ModelList();
		modelList2.add(new ModelValue("NO", false, 0, 0, false, 0, 1, 0, 0));
		modelList2.add(new ModelValue("", false, 0, 1, false, 0, 1, 1, 1));
		modelList2.add(new ModelValue("Ŀ", false, 0, 2, false, 0, 1, 2, 2));
		modelList2.add(new ModelValue("Ŀ", false, 0, 3, false, 0, 1, 3, 3));
		modelList2.add(new ModelValue("Ŀ׶", false, 0, 4, false, 0, 0, 4, 7));
		modelList2.add(new ModelValue("DV", false, 1, 4, false));
		modelList2.add(new ModelValue("PV", false, 1, 5, false));
		modelList2.add(new ModelValue("PR", false, 1, 6, false));
		modelList2.add(new ModelValue("SR", false, 1, 7, false));
		modelList2.add(new ModelValue("ע", false, 0, 8, false, 0, 1, 8, 8));

		String type = null;
		int typeSpan = 0;
		data = TCTableUtil.getTableRows(form, "jd2_xpcsxqd", colNames);
		if (data.length == 0) {

			model2 = new CTMap(dbData.size() + 3, 9);

			for (int i = 0; i < dbData.size(); i++) {
				realIdStr.add(dbData.get(i).getStr("TEST_ID"));
				modelList2.add(new ModelValue(dbData.get(i).getStr("TEST_PROJECT"), false, i + 2, 2, false));
				modelList2.add(new ModelValue(dbData.get(i).getInt("TEST_COST") + "", false, i + 2, 3, false));
				if (i == 0) {
					type = dbData.get(i).getStr("TEST_TYPE");
				}
				if ((type != null && !type.equals(dbData.get(i).getStr("TEST_TYPE")))) {
					System.out.println(type);
					modelList2.add(
							new ModelValue(type, false, i - typeSpan + 2, 1, false, i - typeSpan + 2, i + 1, 1, 1));
					type = dbData.get(i).getStr("TEST_TYPE");
					typeSpan = 0;
				}
				System.out.println(dbData.get(i).toString());
				if (i == dbData.size() - 1) {
					System.out.println(type);
					modelList2.add(
							new ModelValue(type, false, i - typeSpan + 2, 1, false, i - typeSpan + 2, i + 2, 1, 1));
				}
				model2.setValueAt(i + 1, i + 2, 0);
				for (int ii = 4; ii < 8; ii++) {
					model2.setValueAt("/", i + 2, ii);
				}
				typeSpan++;
			}
		} else {
			for (int i = 0; i < data.length; i++) {
				compareDataList.add(data[i]);
				realIdStr.add(data[i][0]);
			}
			for (int i = 0; i < dbData.size(); i++) {
				String realId = dbData.get(i).getStr("TEST_ID");
				String[] rowData;
				if (realIdStr.indexOf(realId) >= 0) {
					rowData = compareDataList.get(realIdStr.indexOf(realId));
					rowData[1] = dbData.get(i).getStr("TEST_TYPE");
					rowData[2] = dbData.get(i).getStr("TEST_PROJECT");
					rowData[3] = dbData.get(i).getStr("TEST_COST");
					compareDataList.set(realIdStr.indexOf(realId), rowData);
				} else {
					rowData = new String[data[0].length];
					rowData[0] = realId;
					rowData[1] = dbData.get(i).getStr("TEST_TYPE");
					rowData[2] = dbData.get(i).getStr("TEST_PROJECT");
					rowData[3] = dbData.get(i).getStr("TEST_COST");
					rowData[data[0].length - 1] = "";
					compareDataList.add(rowData);
				}
			}
			Collections.sort(compareDataList, new Comparator<String[]>() {

				@Override
				public int compare(String[] o1, String[] o2) {
					// TODO Auto-generated method stub
					return o1[1].compareTo(o2[1]);
				}
			});
			data = compareDataList.toArray(new String[compareDataList.size()][]);
			model2 = new CTMap(data.length + 3, 9);
			realIdStr.clear();
			for (int i = 0; i < data.length; i++) {
				realIdStr.add(data[i][0]);
				modelList2.add(new ModelValue(data[i][2] == null ? "" : data[i][2], false, i + 2, 2, false));
				modelList2.add(new ModelValue(data[i][3] == null ? "" : data[i][3], false, i + 2, 3, false));
				if (i == 0) {
					type = data[i][1];
				}
				if ((type != null && !type.equals(data[i][1]))) {
					System.out.println(type);
					modelList2.add(
							new ModelValue(type, false, i - typeSpan + 2, 1, false, i - typeSpan + 2, i + 1, 1, 1));
					type = data[i][1];
					typeSpan = 0;
				}
				System.out.println(Arrays.toString(data[i]));
				if (i == data.length - 1) {
					System.out.println(type);
					modelList2.add(
							new ModelValue(type, false, i - typeSpan + 2, 1, false, i - typeSpan + 2, i + 2, 1, 1));
				}

				model2.setValueAt(i + 1, i + 2, 0);
				for (int ii = 4; ii < 9; ii++) {
					model2.setValueAt((data[i][ii] == null) ? "/" : data[i][ii], i + 2, ii);
				}
				typeSpan++;
			}
		}

		int buttom = data.length == 0 ? dbData.size() + 2 : data.length + 2;
		modelList2.add(new ModelValue("Ŀúϼ", false, buttom, 0, false, buttom, buttom, 0, 2));
		modelList2.add(new ModelValue("jd2_zfy", true, buttom, 3, false));
		modelList2.add(new ModelValue("jd2_dvfy", true, buttom, 4, false));
		modelList2.add(new ModelValue("jd2_pvfy", true, buttom, 5, false));
		modelList2.add(new ModelValue("jd2_prfy", true, buttom, 6, false));
		modelList2.add(new ModelValue("jd2_srfy", true, buttom, 7, false));

		initModel(model2, modelList2);

		table2 = new CTable(model2) {
			@Override
			public boolean isCellEditable(int row, int col) {
				if (modelList2.isDisableEdit(row, col)) {
					return false;
				}
				return true;
			}
		};

		table2.setRowHeight(25);
		table2.setBorder(BorderFactory.createLineBorder(Color.black));
		table2.getColumnModel().getColumn(0).setPreferredWidth(100);
		table2.getColumnModel().getColumn(1).setPreferredWidth(60);
		table2.getColumnModel().getColumn(2).setPreferredWidth(80);
		table2.getColumnModel().getColumn(3).setPreferredWidth(60);
		table2.getColumnModel().getColumn(4).setPreferredWidth(50);
		table2.getColumnModel().getColumn(5).setPreferredWidth(50);
		table2.getColumnModel().getColumn(6).setPreferredWidth(50);
		table2.getColumnModel().getColumn(7).setPreferredWidth(50);
		table2.getColumnModel().getColumn(8).setPreferredWidth(60);
		table2.putClientProperty("terminateEditOnFocusLost", true);

		DefaultTableCellRenderer tcr2 = new DefaultTableCellRenderer() {
			// д
			@Override
			public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
					boolean hasFocus, int row, int column) {
				// TODO Auto-generated method stub

				int maxPreferredHeight = 0;
				for (int i = 0; i < table.getColumnCount(); i++) {
					setText("" + table.getValueAt(row, i));
					setSize(table.getColumnModel().getColumn(column).getWidth(), 0);
					maxPreferredHeight = Math.max(maxPreferredHeight, getPreferredSize().height);
				}
				setBackground(Color.white);
//				if(points1.contains(new Point(row,column)))
//					setForeground(new Color(0,0,255));
//				else
				setForeground(Color.black);
				if (isSelected) {
					setBackground(new Color(0, 120, 215));
					setForeground(Color.white);
				}
				if (table.getRowHeight(row) != maxPreferredHeight) // Ϲæ
					table.setRowHeight(row, maxPreferredHeight);

				setText(value == null ? "" : value.toString());
				return this;
			}
		};

		DefaultCellEditor dce = new DefaultCellEditor(new JTextField()) {
			JTable table;
			int row;
			int col;

			@Override
			public Component getTableCellEditorComponent(JTable paramJTable, Object paramObject, boolean paramBoolean,
					int paramInt1, int paramInt2) {
				this.table = paramJTable;
				this.row = paramInt1;
				this.col = paramInt2;
				return super.getTableCellEditorComponent(paramJTable, paramObject, paramBoolean, paramInt1, paramInt2);
			}

			@Override
			public Object getCellEditorValue() {
				Object obj = super.getCellEditorValue();
				if (obj != null) {
					String objStr = obj.toString().trim();
					try {
						if ("/".equals(objStr) || "".equals(objStr)) {
							objStr = "0";
						}
						int num = Integer.parseInt(objStr);
						System.out.println("ֵ" + num);
						if (num < 0) {
							System.out.println("ֻȻ\"/\"");
							MessageBox.post("ֻȻ\"/\"", "", MessageBox.ERROR);
							return "/";
						}
						int sum = 0;
						Object sumObj;
						for (int i = 2; i < row; i++) {
							sumObj = table.getValueAt(i, col);
							if (sumObj != null && !"/".equals(sumObj.toString().trim())) {
								sum += Double.parseDouble(
										(sumObj = table.getValueAt(i, 3)) == null ? "0" : sumObj.toString().trim());
							}
						}
						if (!"0".equals(objStr)) {
							sum += Double.parseDouble(
									(sumObj = table.getValueAt(row, 3)) == null ? "0" : sumObj.toString().trim());
						}
						for (int i = row + 1; i < table.getRowCount() - 1; i++) {
							sumObj = table.getValueAt(i, col);
							if (sumObj != null && !"/".equals(sumObj.toString().trim())) {
								sum += Double.parseDouble(
										(sumObj = table.getValueAt(i, 3)) == null ? "0" : sumObj.toString().trim());
							}
						}
						table.setValueAt(sum, table.getRowCount() - 1, col);
						double sum1 = Double
								.parseDouble(((sumObj = table.getValueAt(table.getRowCount() - 1, 4)) == null
										|| "".equals(sumObj.toString().trim())) ? "0" : sumObj.toString().trim());
						double sum2 = Double
								.parseDouble(((sumObj = table.getValueAt(table.getRowCount() - 1, 5)) == null
										|| "".equals(sumObj.toString().trim())) ? "0" : sumObj.toString().trim());
						double sum3 = Double
								.parseDouble(((sumObj = table.getValueAt(table.getRowCount() - 1, 6)) == null
										|| "".equals(sumObj.toString().trim())) ? "0" : sumObj.toString().trim());
						double sum4 = Double
								.parseDouble(((sumObj = table.getValueAt(table.getRowCount() - 1, 7)) == null
										|| "".equals(sumObj.toString().trim())) ? "0" : sumObj.toString().trim());
						table.setValueAt(sum1 + sum2 + sum3 + sum4, table.getRowCount() - 1, 3);
						table2.revalidate();
						table2.repaint();
					} catch (NumberFormatException e1) {
						e1.printStackTrace();
						System.out.println("ֻȻ\"/\"");
						MessageBox.post("ֻȻ\"/\"", "", MessageBox.ERROR);
						obj = "/";
					} catch (Exception e2) {
						e2.printStackTrace();
						obj = "/";
					}
				}
				if ("0".equals(obj.toString().trim())) {
					obj = "/";
				}
				return obj;
			}
		};
		tcr2.setHorizontalAlignment(SwingConstants.CENTER);
		table2.getColumnModel().getColumn(4).setCellEditor(dce);
		table2.getColumnModel().getColumn(5).setCellEditor(dce);
		table2.getColumnModel().getColumn(6).setCellEditor(dce);
		table2.getColumnModel().getColumn(7).setCellEditor(dce);
		table2.setAutoResizeMode(CTable.AUTO_RESIZE_NEXT_COLUMN);
		table2.setDefaultRenderer(Object.class, tcr2);
		table2.addMouseListener(rightClick());
		inner.add(table2, BorderLayout.SOUTH);

		JPanel btns = new JPanel(new FlowLayout(FlowLayout.CENTER));
		JButton create = new JButton("Լƻ");
		create.addActionListener(create());
		JButton updateDV = new JButton("DV");
		updateDV.addActionListener(update("DV"));
		JButton updatePV = new JButton("PV");
		updatePV.addActionListener(update("PV"));
		JButton updatePR = new JButton("PR");
		updatePR.addActionListener(update("PR"));
		JButton updateSR = new JButton("SR");
		updateSR.addActionListener(update("SR"));

		JButton testBtn = new JButton("table");
		testBtn.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				String[][] temp = new String[0][];
				TCTableUtil.setTableRows(form, "jd2_xpcsxqd", "JD2_XPCSXQD", colNames, temp);
//				try {
//					Map<String, String> testMap = ((TCComponentItemRevision) form.whereReferenced()[0].getComponent())
//							.getClassificationAttributes();
//					for (Entry<String, String> entry : testMap.entrySet()) {
//						System.out.println(entry.getKey() + "====>" + entry.getValue());
//					}
//				} catch (TCException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//				}
				testFlag = true;
			}
		});
		btns.add(create);
		btns.add(updateDV);
		btns.add(updatePV);
		btns.add(updatePR);
		btns.add(updateSR);
		btns.add(testBtn);

		menu.setVisible(false);
		addR = new JMenuItem("");
		addR.setEnabled(false);
		addR.addActionListener(addRow());
		menu.add(addR);

		JScrollPane jsp = new JScrollPane(inner);
		root.add(jsp, BorderLayout.CENTER);
		root.add(btns, BorderLayout.SOUTH);
		this.add(root);
	}

	@Override
	public void saveRendering() {
		if (testFlag) {
			return;
		}
		saveModel(table1, modelList1);
		saveModel(table2, modelList2);

		Object obj;
		if (data.length == 0) {
			if (dbData.size() == 0) {
				try {
					dbData = Db.use(DBUtil.getDataSource(session))
							.query("select * from JD2_Machine ORDER BY TEST_TYPE ASC");
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			data = new String[table2.getRowCount() - 3][9];

			for (int i = 0; i < dbData.size(); i++) {
				data[i][0] = dbData.get(i).getStr("TEST_ID");
				data[i][1] = dbData.get(i).getStr("TEST_TYPE");
				data[i][2] = dbData.get(i).getStr("TEST_PROJECT");
				data[i][3] = dbData.get(i).getStr("TEST_COST");
				for (int ii = 4; ii < 9; ii++) {
					data[i][ii] = (obj = model2.getValueAt(i + 2, ii)) == null ? "" : obj.toString();
				}
			}
			System.out.println("dbData.size() " + dbData.size());
			System.out.println("table2.getRowCount() " + table2.getRowCount());
			for (int i = dbData.size(); i < table2.getRowCount() - 3; i++) {
				data[i][0] = realIdStr.get(i);
				for (int ii = 1; ii < 9; ii++) {
					data[i][ii] = (obj = model2.getValueAt(i + 2, ii)) == null ? "" : obj.toString();
				}
			}
			System.out.println(Arrays.deepToString(data));
			TCTableUtil.setTableRows(form, "jd2_xpcsxqd", "JD2_XPCSXQD", colNames, data);
		} else {
			String[][] newData = new String[table2.getRowCount() - 3][9];
			for (int i = 0; i < data.length; i++) {
				System.arraycopy(data[i], 0, newData[i], 0, 4);
				for (int ii = 4; ii < 9; ii++) {
					newData[i][ii] = (obj = model2.getValueAt(i + 2, ii)) == null ? "" : obj.toString();
				}
			}
			for (int i = data.length; i < table2.getRowCount() - 3; i++) {
				newData[i][0] = realIdStr.get(i);
				for (int ii = 1; ii < 9; ii++) {
					newData[i][ii] = (obj = model2.getValueAt(i + 2, ii)) == null ? "" : obj.toString();
				}
			}
			System.out.println(Arrays.deepToString(newData));
			TCTableUtil.setTableRows(form, "jd2_xpcsxqd", "JD2_XPCSXQD", colNames, newData);
		}
	}

	private MouseAdapter rightClick() {
		return new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getButton() == MouseEvent.BUTTON3 && form.isCheckedOut() && table2.getSelectedRow() != -1) {
					int row = table2.getSelectedRow();
					boolean flag = (row > 1 && row < table2.getRowCount() - 1);
					addR.setEnabled(flag);
					menu.show(e.getComponent(), e.getX(), e.getY());
				}
			}
		};
	}

	private ActionListener addRow() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent paramActionEvent) {
				// TODO Auto-generated method stub
				int row = model2.getRowCount() - 2;
				int num = Integer.parseInt(model2.getValueAt(row, 0).toString());
				modelList2.findAndAddRow(row + 1, table2.getColumnCount(), 1);
				model2.insertRow(model2.getRowCount() - 1);
				realIdStr.add(System.currentTimeMillis() + "");
				model2.setValueAt(num + 1, row + 1, 0);
				for (int i = 4; i < 8; i++) {
					model2.setValueAt("/", row + 1, i);
				}
				table2.revalidate();
				table2.repaint();
			}
		};
	}

	private ActionListener create() {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent paramActionEvent) {
				// TODO Auto-generated method stub
				try {
					StringBuilder msg = new StringBuilder();
					TCComponentItemRevision rev = (TCComponentItemRevision) form.whereReferenced()[0].getComponent();
					TCComponent[] comps = rev.getRelatedComponents("JD2_CSJH");
					String exist = "";
					for (TCComponent t : comps) {
						exist += t.getProperty("object_name");
					}
					List<String[]> colData = new ArrayList<String[]>();
					String ownner = form.getTCProperty("owning_user").getUIFValue();
					for (int i = 0; i < 4; i++) {
						if (exist.contains(jieduan[i])) {
							System.out.println("\"" + jieduan[i] + "׶\"ԼƻѴ");
							msg.append("\"" + jieduan[i] + "׶\"ԼƻѴ\n");
							continue;
						}
						Object obj;
						Object temp;
						for (int ii = 2; ii < table2.getRowCount() - 1; ii++) {
							obj = table2.getValueAt(ii, i + 4);
							if (obj != null && !"/".equals(obj.toString().trim())) {
								// colNames2 = { "jd2_no", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syfy",
								// "jd2_sycs" };
								String[] row = new String[6];
								row[0] = realIdStr.get(ii - 2);
								row[1] = ownner;
								row[2] = (temp = table2.getValueAt(ii, 2)) == null ? "" : temp.toString();
								row[3] = obj.toString().trim();
								row[4] = (temp = table2.getValueAt(ii, 3)) == null ? "0" : temp.toString().trim();
								row[5] = "1";
								System.out.println(Arrays.toString(row));
								colData.add(row);
							}
						}
						if (colData.size() != 0) {
							TCComponentItemType type = (TCComponentItemType) session.getTypeComponent("JD2_GTXPXMCSJH");
							TCComponentItem item = type.create(null, null, "JD2_GTXPXMCSJH", jieduan[i] + "׶βԼƻ", "",
									null);
							rev.add("JD2_CSJH", item);
							TCComponentItemRevision rev1 = item.getLatestItemRevision();
							TCComponentForm form1 = (TCComponentForm) rev1
									.getRelatedComponents("IMAN_master_form_rev")[0];
							String[][] dataArr = colData.toArray(new String[colData.size()][6]);
							System.out.println(Arrays.deepToString(dataArr));
							TCTableUtil.setTableRows(form1, "jd2_csjhtable", "JD2_CSJHTABLE", colNames2, dataArr);
							msg.append("\"" + jieduan[i] + "׶\"Լƻɹ\n");
						}
						colData.clear();
					}

					MessageBox.post(msg.toString(), "ʾ", MessageBox.WARNING);
				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		};
	}

	@Override
	public boolean isRenderingModified() {
		// TODO Auto-generated method stub
		return form.isCheckedOut();
	}

//	String[] textArr1 = { "ĿϢ", "ʱ䣺", "ͺţ", "ͺţ", "Ʒͺţ", "Ŀϣ", "Ʒ", "Ʒ㣺", "Ʒʾ", "ճ̣",
//			"ȼ", "׶Σ" };
//	String[] propArr = { "jd2_xmxx", "jd2_lxsj", "jd2_jbxh", "jd2_csxh", "jd2_cpxh", "jd2_xmzl", "jd2_cpjl",
//			"jd2_cpbgd", "jd2_pzjl", "jd2_kfrc", "jd2_kfdj", "jd2_kfjd" };
	private void initModel(CTMap model, ModelList modelList) {
		try {
			TCComponentItemRevision rev = (TCComponentItemRevision) form.whereReferenced()[0].getComponent();
			AIFComponentContext[] aifs = rev.whereReferenced();
			for (AIFComponentContext aif : aifs) {
				if (aif.getComponent() instanceof TCComponentProject) {
					project = (TCComponentProject) aif.getComponent();
					break;
				}
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		for (ModelValue mv : modelList) {
			if (mv.isProp()) {
				if (prop.containsKey(mv.getValue())) {
					if (modelList == modelList1 && project != null) {
						// ӳ
						try {
							switch (mv.getValue()) {
							case "jd2_lxsj":
								model.setValueAt(project.getProperty("creation_date"), mv.getRow(), mv.getCol());
								break;
							case "jd2_xmxx":
								model.setValueAt(project.getProjectID(), mv.getRow(), mv.getCol());
								break;
							case "jd2_jbxh":
								model.setValueAt(project.getProperty("jd2_cpxh"), mv.getRow(), mv.getCol());
								break;
							case "jd2_kfdj":
								model.setValueAt(project.getProperty("jd2_xmdj"), mv.getRow(), mv.getCol());
								break;
							case "jd2_kfjd":
								String str = form.getProperty("jd2_kfjd");
								JCheckPanel checkPanel = new JCheckPanel(jieduan, false);
								checkPanel.setSelected(str);
								model.setValueAt(checkPanel, mv.getRow(), mv.getCol());
								table1.getColumnModel().getColumn(mv.getCol())
										.setCellEditor(new MyCellEditor3(new JTextField()));
								break;
							case "jd2_cpbgd":
								TCComponent[] cpbgd = project.getRelatedComponents("jd2_cpbgd");// ֪ʲô
								if (cpbgd.length > 0) {
									String displayValue = "";
									for (TCComponent comp : cpbgd) {
										displayValue += comp.toString() + ";";
									}
									model.setValueAt(displayValue, mv.getRow(), mv.getCol());
									table1.addMouseListener(openCPBGD(cpbgd, mv));
								}
								break;
							case "jd2_kfrc":
								TCComponent[] kfrc = project.getRelatedComponents("jd2_kfrc");
								if (kfrc.length > 0) {
									TCComponentSchedule schedule = (TCComponentSchedule) kfrc[0];
									TCComponent[] tasks = schedule.getAllTasks();
									String startTime = "";
									String endTime = "";
									for (TCComponent task : tasks) {
										if ("".equals(task.getProperty("object_name"))) {
											startTime = task.getProperty("");
										}
										if ("СPRA".equals(task.getProperty("object_name"))) {
											endTime = task.getProperty("");
										}
									}
									if (!"".equals(startTime) || !"".equals(endTime)) {
										model.setValueAt(startTime + "-" + endTime, mv.getRow(), mv.getCol());
									}
								}
								break;
							default:
								if ("".equals(prop.get(mv.getValue()))) {
									model.setValueAt("/", mv.getRow(), mv.getCol());
								} else {
									model.setValueAt(prop.get(mv.getValue()), mv.getRow(), mv.getCol());
								}
							}
						} catch (TCException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}

					} else {
						model.setValueAt(prop.get(mv.getValue()), mv.getRow(), mv.getCol());
					}
				} else {
					System.out.println("ԡ" + mv.getValue() + "");
				}
			} else {
				model.setValueAt(mv.getValue(), mv.getRow(), mv.getCol());
			}
			if (mv.isCombine()) {
				model.combine(mv.getCombineRows(), mv.getCombineColumns());
			}
		}

	}

	private MouseAdapter openCPBGD(TCComponent[] cpbgd, ModelValue mv) {
		return new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2 && table1.getSelectedRow() == mv.getRow()
						&& table1.getSelectedColumn() == mv.getCol()) {
					try {
						if (cpbgd.length > 1) {
							List<String[]> data = new ArrayList<String[]>();
							for (TCComponent comp : cpbgd) {
								data.add(new String[] { data.size() + 1 + "", comp.toString() });
							}
							DialogUtil.TableMsg msg = DialogUtil.createTableMsg(new String[] { "", "" }, data);
							int res = JOptionPane.showConfirmDialog($this, msg.panel, "ѡ", JOptionPane.PLAIN_MESSAGE);
							if (res == JOptionPane.OK_OPTION) {
								if (msg.table.getSelectedRow() > 0) {
									TCComponentItem item = (TCComponentItem) cpbgd[msg.table.getSelectedRow()];
									TCComponent[] tccitem = item.getLatestItemRevision()
											.getTCProperty("IMAN_specification").getReferenceValueArray();
									TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
									dataset.open();
								}
							}
						} else {
							TCComponentItem item = (TCComponentItem) cpbgd[0];
							TCComponent[] tccitem = item.getLatestItemRevision().getTCProperty("IMAN_specification")
									.getReferenceValueArray();
							TCComponentDataset dataset = (TCComponentDataset) tccitem[0];
							dataset.open();
						}
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
			}
		};
	}

	private void saveModel(JTable table, ModelList modelList) {
		Object obj;
		for (ModelValue mv : modelList) {
			if (mv.isProp()) {
				if (prop.containsKey(mv.getValue())) {
					obj = table.getValueAt(mv.getRow(), mv.getCol());
					if (modelList == modelList1 && project != null) {
						if ("jd2_kfjd".equals(mv.getValue())) {
							obj = table.getValueAt(mv.getRow(), mv.getCol());
							if (obj != null) {
								String selectedText = ((JCheckPanel) obj).getSelectedText();
								try {
									form.setProperty(mv.getValue(), selectedText);
								} catch (TCException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
						}
					}
					try {
						form.setProperty(mv.getValue(), obj == null ? "" : obj.toString());
					} catch (TCException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				} else {
					System.out.println("\"" + mv.getValue() + "\"");
				}
			}
		}
	};

	private ActionListener update(String jieduanStr) {
		return new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent paramActionEvent) {
				// TODO Auto-generated method stub
				try {
					TCComponentItemRevision rev = (TCComponentItemRevision) form.whereReferenced()[0].getComponent();
					TCComponent[] comps = rev.getRelatedComponents("JD2_CSJH");
					TCComponentItem item = null;
					for (TCComponent comp : comps) {
						System.out.println(comp.getProperty("object_string"));
						if (comp.getProperty("object_string").contains(jieduanStr)) {
							item = (TCComponentItem) comp;
							break;
						}
					}
					if (item == null) {
						MessageBox.post("\"" + jieduanStr + "׶\"Լƻδȴ", "ʾ", MessageBox.WARNING);
						return;
					}

					TCComponentItemRevision rev1 = item.getLatestItemRevision();
					TCComponentForm form1 = (TCComponentForm) rev1.getRelatedComponents("IMAN_master_form_rev")[0];
					List<Map<String, String>> tableRows = TCTableUtil.getTableMapList(form1, "jd2_csjhtable",
							colNames3);
					List<String> realNo = new ArrayList<String>();
					for (Map<String, String> map : tableRows) {
						realNo.add(map.get("jd2_no"));
					}

					String ownner = form.getTCProperty("owning_user").getUIFValue();
					Object obj, temp;
					List<String> jieduanList = Arrays.asList(jieduan);
					for (int i = 2; i < table2.getRowCount() - 1; i++) {
						obj = table2.getValueAt(i, jieduanList.indexOf(jieduanStr) + 4);
						if (obj != null && !"/".equals(obj.toString().trim())) {
							// colNames2 = { "jd2_no", "jd2_wtry", "jd2_syxm", "jd2_syts", "jd2_syfy",
							// "jd2_sycs" };
							Map<String, String> tempMap;
							if (realNo.contains(realIdStr.get(i - 2))) {
								int index = realNo.indexOf(realIdStr.get(i - 2));
								for (int ii = index; ii < realNo.size(); ii++) {// ٴظrealNo
									if (realNo.get(ii).equals(realIdStr.get(i - 2))) {
										tempMap = tableRows.get(ii);
										tempMap.put("jd2_syxm",
												(temp = table2.getValueAt(i, 2)) == null ? "" : temp.toString());
										tempMap.put("jd2_syts", obj.toString().trim());
										tempMap.put("jd2_syfy",
												(temp = table2.getValueAt(i, 3)) == null ? "" : temp.toString());
										tableRows.set(ii, tempMap);
									}
								}
							} else {
								tempMap = new HashMap<String, String>();
								tempMap.put("jd2_no", realIdStr.get(i - 2));
								tempMap.put("jd2_wtry", ownner);
								tempMap.put("jd2_syxm",
										(temp = table2.getValueAt(i, 2)) == null ? "" : temp.toString());
								tempMap.put("jd2_syts", obj.toString().trim());
								tempMap.put("jd2_syfy",
										(temp = table2.getValueAt(i, 3)) == null ? "0" : temp.toString().trim());
								tempMap.put("jd2_sycs", "1");
								tableRows.add(tempMap);
							}
						}
					}
					TCTableUtil.setTableMapList(form1, "jd2_csjhtable", "JD2_CSJHTABLE", tableRows);
					MessageBox.post("³ɹ", "ʾ", MessageBox.WARNING);

				} catch (TCException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		};
	}

}
