package com.connor.jd.plm.form;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

public class PhotoFrame extends JFrame {

	private static final long serialVersionUID = -2216276219179107707L;
	private Container con;

	private ZPanel zPanel;
	private JScrollPane imgSp;
	private static PhotoFrame instance;

	public static PhotoFrame getInstance(String imgPath) {
		if (instance == null) {
			instance = new PhotoFrame(imgPath);
		} else {
			instance.zPanel.setImagePath(imgPath);
			instance.setVisible(true);
			instance.zPanel.setPreferredSize(
					new Dimension(instance.zPanel.getImgWidth(),
							instance.zPanel.getImgHeight()));
		}
		return instance;
	}

	private PhotoFrame(String imgPath) {
		init(imgPath);
		finalSetting();
	}

	private void init(String imgPath) {
		con = getContentPane();

		zPanel = new ZPanel();
		zPanel.setImagePath(imgPath);
		zPanel.setPreferredSize(
				new Dimension(zPanel.getImgWidth(), zPanel.getImgHeight()));

		imgSp = new JScrollPane();
		imgSp.setViewportView(zPanel);
		imgSp.setHorizontalScrollBarPolicy(
				JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		imgSp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

		con.add(imgSp, BorderLayout.CENTER);
	}

	private void finalSetting() {
		setTitle("Ԥ");

		Toolkit kit = Toolkit.getDefaultToolkit();
		Dimension screenSize = kit.getScreenSize();
		int screenHeight = screenSize.height;
		int screenWidth = screenSize.width;
		int frameH = getHeight();
		int frameW = getWidth();
		setLocation((screenWidth - frameW) / 2 - 250,
				(screenHeight - frameH) / 2 - 250);
		setSize(screenWidth / 2, screenHeight / 2);
		setVisible(true);
		setResizable(true);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		super.dispose();
		System.out.println("Ԥر");
		zPanel.clear();
	}
}