package com.connor.jd.plm.table;

import java.util.ArrayList;
import java.util.List;

public class ModelList extends ArrayList<ModelValue> {

	private List<String> disableEdit = new ArrayList<String>();

	@Override
	public boolean add(ModelValue e) {
		// TODO Auto-generated method stub
		if (!e.isEditable()) {
			disableEdit.add(e.getRow() + "," + e.getCol());
		}
		return super.add(e);
	}

	public ModelValue getModelValue(int row, int col) {
		for (ModelValue mv : this) {
			if (mv.getRow() == row && mv.getCol() == col) {
				return mv;
			}
		}
		return null;
	}

	public ModelValue getModelValueInRange(int row, int col) {
		int rowStart;
		int colStart;
		int rowEnd;
		int colEnd;
		for (ModelValue mv : this) {
			if (mv.isCombine()) {
				rowStart = mv.getCombineRows()[0];
				rowEnd = rowStart + mv.getRowSpan() - 1;
				colStart = mv.getCombineColumns()[0];
				colEnd = colStart + mv.getColSpan() - 1;
				if (row >= rowStart && row <= rowEnd && col >= colStart && col <= colEnd) {
					return mv;
				}
			}
		}
		return null;
	}

	public boolean addDisableEdit(int row, int col) {
		String str = row + "," + col;
		if (disableEdit.contains(str)) {
			disableEdit.add(disableEdit.indexOf(str), str);
			return true;
		}
		disableEdit.add(str);
		return false;
	}

	public boolean removeDisableEdit(int row, int col) {
		String str = row + "," + col;
		if (disableEdit.contains(str)) {
			disableEdit.remove(disableEdit.indexOf(str));
			return true;
		}
		return false;
	}

	public boolean isDisableEdit(int row, int col) {
		return disableEdit.contains(row + "," + col);
	}

	public void findAndAddRow(int row, int tableColumsCount, int offset) {
		if (offset <= 0) {
			return;
		}
		if (this.size() == 0) {
			return;
		}
		for (int i = 0; i < tableColumsCount; i++) {
			if (this.getModelValue(row, i) != null) {
				System.out.println(this.getModelValue(row, i).getValue());
				this.getModelValue(row, i).setRow(row + offset);
				this.removeDisableEdit(row, i);
				this.addDisableEdit(row + offset, i);
			}
		}
	}

}
