package com.connor.jd.plm.table;

import java.util.Objects;

public class ModelValue {

	private String value;
	private boolean isProp;
	private int row;
	private int col;
	private boolean editable;
	private int[] combineRows;
	private int rowSpan;
	private int[] combineColumns;
	private int colSpan;

	public ModelValue(String value, boolean isProp, int row, int col, boolean editable, int[] combineRows,
			int[] combineColumns, String type) {
		super();
		this.value = value;
		this.isProp = isProp;
		this.row = row;
		this.col = col;
		this.editable = editable;
		this.combineRows = combineRows;
		this.combineColumns = combineColumns;
	}

	public ModelValue(boolean editable, int[] combineRows, int[] combineColumns) {
		super();
		this.editable = editable;
		this.combineRows = combineRows;
		this.combineColumns = combineColumns;
	}

	public ModelValue(String value, boolean isProp, int row, int col, boolean editable) {
		super();
		this.value = value;
		this.isProp = isProp;
		this.row = row;
		this.col = col;
		this.editable = editable;
	}

	public ModelValue(String value, boolean isProp, int row, int col, boolean editable, int[] combineRows,
			int[] combineColumns) {
		super();
		this.value = value;
		this.isProp = isProp;
		this.row = row;
		this.col = col;
		this.editable = editable;
		this.combineRows = combineRows;
		this.combineColumns = combineColumns;
	}

	public ModelValue(String value, boolean isProp, int row, int col, boolean editable, int rowStart, int rowEnd,
			int colStart, int colEnd) {
		super();
		this.value = value;
		this.isProp = isProp;
		this.row = row;
		this.col = col;
		this.editable = editable;
		setCombineRows(rowStart, rowEnd);
		setCombineColumns(colStart, colEnd);
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public int getRow() {
		return row;
	}

	public void setRow(int row) {
		this.row = row;
	}

	public int getCol() {
		return col;
	}

	public void setCol(int col) {
		this.col = col;
	}

	public boolean isEditable() {
		return editable;
	}

	public void setEditable(boolean editable) {
		this.editable = editable;
	}

	public int[] getCombineRows() {
		return combineRows;
	}

	public void setCombineRows(int[] combineRows) {
		this.rowSpan = combineRows.length;
		this.combineRows = combineRows;
	}

	public void setCombineRows(int start, int end) {
		if (start <= end) {
			this.rowSpan = end - start + 1;
			this.combineRows = new int[rowSpan];
			for (int i = 0; i < rowSpan; i++) {
				combineRows[i] = start + i;
			}
		}
	}

	public int[] getCombineColumns() {
		return combineColumns;
	}

	public void setCombineColumns(int[] combineColumns) {
		this.colSpan = combineColumns.length;
		this.combineColumns = combineColumns;
	}

	public void setCombineColumns(int start, int end) {
		if (start <= end) {
			this.colSpan = end - start + 1;
			this.combineColumns = new int[colSpan];
			for (int i = 0; i < colSpan; i++) {
				combineColumns[i] = start + i;
			}
		}
	}

	public int getRowSpan() {
		return rowSpan;
	}

	public int getColSpan() {
		return colSpan;
	}

	public boolean isProp() {
		return isProp;
	}

	public void setProp(boolean isProp) {
		this.isProp = isProp;
	}

	public boolean hasValue() {
		return Objects.nonNull(value);
	}

	public boolean isCombine() {
		return rowSpan != 0 && colSpan != 0;
	}

}
