package com.connor.jd.plm.table;

import java.awt.Component;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.JTextField;

import com.teamcenter.rac.util.MessageBox;

public class MyCellEditor extends DefaultCellEditor {
	private JRadioPanel radio = null;
	private JCheckPanel check = null;
	private JComboBox<String> comboBox = null;
	private int type = -1;
	private int row;
	private int col;
	private int top;
	private int end;
	private int bottom;
	private JTable table;

	public MyCellEditor(JTextField var1) {
		super(var1);
		// TODO Auto-generated constructor stub
	}

	public MyCellEditor(JTextField var1, int top, int end, int bottom) {
		super(var1);
		// TODO Auto-generated constructor stub
		this.top = top;
		this.end = end;
		this.bottom = bottom;
	}

	@Override
	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
		if (value instanceof JRadioPanel) {
			radio = (JRadioPanel) value;
			type = 1;
			return radio;
		} else if (value instanceof JCheckPanel) {
			check = (JCheckPanel) value;
			type = 2;
			return check;
		} else if (value instanceof JComboBox) {
			comboBox = (JComboBox<String>) value;
			type = 3;
			return comboBox;
		}
		this.row = row;
		this.col = column;
		this.bottom = table.getRowCount() - end;
		this.table = table;
		type = 0;
		return super.getTableCellEditorComponent(table, value, isSelected, row, column);
	}

	@Override
	public Object getCellEditorValue() {
		if (type == 1) {
			return radio;
		}
		if (type == 2) {
			return check;
		}
		if (type == 3) {
			return comboBox;
		}

		Object obj = super.getCellEditorValue();
		if (obj != null && !"".equals(obj.toString().trim()) && row >= top && row <= bottom && col >= 7
				&& col < table.getColumnCount() - 3) {
			try {
				Double.parseDouble(obj.toString().trim());
			} catch (Exception e) {
				MessageBox.post("ֻ", "", MessageBox.ERROR);
				return null;
			}
		}
		return obj;
	}

	@Override
	public boolean stopCellEditing() {
		// TODO Auto-generated method stub
		if (row >= top && row <= bottom && col >= 7 && col < table.getColumnCount() - 3) {
			double min = Double.MAX_VALUE;
			double max = Double.MIN_VALUE;
			Object obj;
			for (int i = 7; i < col; i++) {
				obj = table.getValueAt(row, i);
				if (obj != null && !"".equals(obj.toString().trim())) {
					min = Math.min(min, Double.parseDouble(obj.toString().trim()));
					max = Math.max(max, Double.parseDouble(obj.toString().trim()));
				}
			}
			obj = getCellEditorValue();
			if (obj != null && !"".equals(obj.toString().trim())) {
				min = Math.min(min, Double.parseDouble(obj.toString().trim()));
				max = Math.max(max, Double.parseDouble(obj.toString().trim()));
			}
			for (int i = col + 1; i < table.getColumnCount() - 3; i++) {
				obj = table.getValueAt(row, i);
				if (obj != null && !"".equals(obj.toString().trim())) {
					min = Math.min(min, Double.parseDouble(obj.toString().trim()));
					max = Math.max(max, Double.parseDouble(obj.toString().trim()));
				}
			}
			if (max > Double.MIN_VALUE) {
				table.setValueAt(String.format("%.2f", min), row, table.getColumnCount() - 3);
				table.setValueAt(String.format("%.2f", max), row, table.getColumnCount() - 2);
			} else {
				table.setValueAt("", row, table.getColumnCount() - 3);
				table.setValueAt("", row, table.getColumnCount() - 2);
			}
		}
		return super.stopCellEditing();
	}

}
