package com.connor.jd.plm.table;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentForm;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.schemas.soa._2006_03.exceptions.ServiceException;
import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateIn;
import com.teamcenter.services.rac.core._2008_06.DataManagement.CreateResponse;

public class TCTableUtil {
	public static String[][] getTableRows(TCComponentForm form, String prop, String[] colNames) {
		try {
			TCProperty tcProperty = form.getTCProperty(prop);
			TCComponent[] components = tcProperty.getReferenceValueArray();
			String[][] res = new String[components.length][colNames.length];
			for (int i = 0; i < components.length; i++) {
				for (int ii = 0; ii < colNames.length; ii++) {
					res[i][ii] = components[i].getPropertyDisplayableValue(colNames[ii]);
				}
			}
			return res;
		} catch (NullPointerException e) {
			System.out.println("\"" + prop + "\"");
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block

			e.printStackTrace();
		}

		return null;
	}

	public static List<Map<String, String>> getTableMapList(TCComponentForm form, String prop, String[] colNames) {
		try {
			TCProperty tcProperty = form.getTCProperty(prop);
			TCComponent[] components = tcProperty.getReferenceValueArray();
			List<Map<String, String>> res = new ArrayList<Map<String, String>>();
			for (int i = 0; i < components.length; i++) {
				Map<String, String> temp = new HashMap<String, String>();
				for (int ii = 0; ii < colNames.length; ii++) {
					temp.put(colNames[ii], components[i].getPropertyDisplayableValue(colNames[ii]));
				}
				res.add(temp);
			}
			return res;
		} catch (NullPointerException e) {
			System.out.println("\"" + prop + "\"");
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block

			e.printStackTrace();
		}

		return null;
	}

	public static boolean setTableRows(TCComponentForm form, String prop, String refName, String[] colNames,
			String[][] rows) {
		List<TCComponent> list = new ArrayList<TCComponent>();
		DataManagementService service = DataManagementService
				.getService((TCSession) AIFUtility.getCurrentApplication().getSession());
		CreateIn ci = new CreateIn();
		ci.data.boName = refName;
		Map<String, String> map = new HashMap<String, String>();
		for (int i = 0; i < rows.length; i++) {
			for (int ii = 0; ii < colNames.length; ii++) {
				map.put(colNames[ii], rows[i][ii]);
			}
			System.out.println(map.size());
			ci.data.stringProps = map;
			try {
				CreateResponse response = service.createObjects(new CreateIn[] { ci });
				System.out.println("CreateResponse size:" + response.serviceData.sizeOfCreatedObjects());
				if (response.serviceData.sizeOfCreatedObjects() > 0) {
					list.add(response.output[0].objects[0]);
				} else {
					String str = String.join(",", response.serviceData.getPartialError(0).getMessages());
					System.out.println(str);
				}
			} catch (ServiceException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		try {
			form.getTCProperty(prop).setReferenceValueArray(list.toArray(new TCComponent[list.size()]));
			System.out.println("tableɹ");
			return true;
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}

	public static boolean setTableMapList(TCComponentForm form, String prop, String refName,
			List<Map<String, String>> dataList) {
		List<TCComponent> list = new ArrayList<TCComponent>();
		DataManagementService service = DataManagementService
				.getService((TCSession) AIFUtility.getCurrentApplication().getSession());
		CreateIn ci = new CreateIn();
		ci.data.boName = refName;
		for (int i = 0; i < dataList.size(); i++) {
			System.out.println(dataList.get(i).size());
			ci.data.stringProps = dataList.get(i);
			try {
				CreateResponse response = service.createObjects(new CreateIn[] { ci });
				System.out.println("CreateResponse size:" + response.serviceData.sizeOfCreatedObjects());
				if (response.serviceData.sizeOfCreatedObjects() > 0) {
					list.add(response.output[0].objects[0]);
				} else {
					String str = String.join(",", response.serviceData.getPartialError(0).getMessages());
					System.out.println(str);
				}
			} catch (ServiceException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		try {
			form.getTCProperty(prop).setReferenceValueArray(list.toArray(new TCComponent[list.size()]));
			System.out.println("tableɹ");
			return true;
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}
}
