package com.connor.jd.plm.utils;

import java.awt.Component;
import java.util.Vector;

import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JComboBox;
import javax.swing.JList;

import com.connor.jd.plm.beans.CheckBoxPo;

public class KeyValComboBox extends JComboBox {

	public KeyValComboBox(Vector values) {
		super(values);
		rendererData(); // Ⱦ
	}

	public void rendererData() {
		DefaultListCellRenderer render = new DefaultListCellRenderer() {
			@Override
			public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected,
					boolean cellHasFocus) {
				super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
				if (value instanceof CheckBoxPo) {
					CheckBoxPo po = (CheckBoxPo) value;
					this.setText(po.text);
				}
				return this;
			}
		};
		this.setRenderer(render);
	}

	// ޸Comboxе
	public void updateData(Vector values) {
		setModel(new DefaultComboBoxModel(values));
		rendererData();
	}

	@Override
	public void setSelectedItem(Object anObject) { // ѡtext봫Ĳͬ
		if (anObject != null) {
			if (anObject instanceof CheckBoxPo) {
				super.setSelectedItem(anObject);
			}
			if (anObject instanceof String) {
				for (int index = 0; index < getItemCount(); index++) {
					CheckBoxPo po = (CheckBoxPo) getItemAt(index);
					if (po.text.equals(anObject.toString())) {
						super.setSelectedIndex(index);
					}
				}
			}
		} else {
			super.setSelectedItem(anObject);
		}
	}

	public void setSelectedValue(Object anObject) { // ѡvalue봫Ĳͬ
		if (anObject != null) {
			if (anObject instanceof CheckBoxPo) {
				super.setSelectedItem(anObject);
			}
			if (anObject instanceof String) {
				for (int index = 0; index < getItemCount(); index++) {
					CheckBoxPo po = (CheckBoxPo) getItemAt(index);
					if (po.value.equals(anObject.toString())) {
						super.setSelectedIndex(index);
					}
				}
			}
		} else {
			super.setSelectedItem(anObject);
		}
	}

	// ѡļֵ
	public Object getSelectedValue() {
		if (getSelectedItem() instanceof CheckBoxPo) {
			CheckBoxPo po = (CheckBoxPo) getSelectedItem();
			return po.value;
		}
		return (getSelectedItem() != null) ? getSelectedItem().toString() : null;
	}

	// ѡʾı
	public String getSelectedText() {
		if (getSelectedItem() instanceof CheckBoxPo) {
			CheckBoxPo po = (CheckBoxPo) getSelectedItem();
			return po.text;
		}
		return (getSelectedItem() != null) ? getSelectedItem().toString() : null;
	}
}