package com.connor.jd.plm.handlers;

import java.text.MessageFormat;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.schedule.commands.newschedule.NewScheduleHandler;
import com.teamcenter.rac.schedule.plugin.Activator;
import com.teamcenter.rac.schedule.project.sharedUtils.TimeZoneCalUtil;
import com.teamcenter.rac.schedule.wizardpages.SchedulePageModel;
import com.teamcenter.rac.ui.commands.handlers.NewBOHandler;
import com.teamcenter.rac.util.Registry;

public class Wf001ScheduleHandler extends NewBOHandler {

	private TCSession session;

	public Wf001ScheduleHandler() {
	}

	public static SchedulePageModel getScheduleModel() {
		if (scheduleModel == null)
			scheduleModel = new SchedulePageModel();
		return scheduleModel;
	}

	@Override
	public Object execute(ExecutionEvent executionevent) throws ExecutionException {
		AbstractAIFApplication app = AIFUtility.getCurrentApplication();
		session = (TCSession) app.getSession();
		InterfaceAIFComponent targetComp = app.getTargetComponent();
		if (targetComp == null) {
			return null;
		}

		scheduleModel = null;
		wizardId = "com.teamcenter.rac.schedule.commands.newschedule.GenericScheduleWizard";
		TCSession tcsession = (TCSession) Activator.getDefault().getSessionService().getDefaultSession();
		TCPreferenceService tcpreferenceservice = tcsession.getPreferenceService();
		String s = tcpreferenceservice.getString(4, "SiteTimeZone", "null");
		IWorkbench iworkbench = PlatformUI.getWorkbench();
		IWorkbenchWindow iworkbenchwindow = iworkbench.getActiveWorkbenchWindow();
		Shell shell = iworkbenchwindow.getShell();
		if ("null".equals(s) || s == null) {
			MessageDialog.openInformation(shell, textRegistry.getString("tzNotSet.TITLE"),
					textRegistry.getString("tzNotSet.MSG"));
			return Boolean.valueOf(false);
		}
		if (!TimeZoneCalUtil.testTimeZoneID(s)) {
			String s1 = textRegistry.getString("tzInvalid.MSG");
			s1 = MessageFormat.format(s1, new Object[] { s });
			MessageDialog.openInformation(shell, textRegistry.getString("tzInvalid.TITLE"), s1);
			return Boolean.valueOf(false);
		} else {
			return super.execute(executionevent);
		}
//
//		} else 
//			

//		if (targetComp.getType().equals("TC_Project")) {
//
//			CreateScheduleOperation operation = new CreateScheduleOperation(targetComp,session);
//			 session.queueOperation(operation);
//
//			return null;
//		} else {
//			MessageBox.post("ÇëÑ¡ÖÐÏîÄ¿Ö´ÐÐ´´½¨!!", "´íÎó", MessageBox.ERROR);
//			return null;
	}

	@Override
	public String getWizardTitle() {
		Registry registry = Registry.getRegistry(NewScheduleHandler.class);
		return registry.getString("dialog.TITLE");
	}

	private static SchedulePageModel scheduleModel = null;
	private final Registry textRegistry = Registry.getRegistry("com.teamcenter.rac.schedule.schedule");

}

/*
 * DECOMPILATION REPORT
 * 
 * Decompiled from:
 * D:\Teamcenter_4Sh\OTW11\rac\plugins\com.teamcenter.rac.schedule_11000.2.0.jar
 * Total time: 1083 ms Jad reported messages/errors: Exit status: 0 Caught
 * exceptions:
 */