package com.connor.jd.plm.utils;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog.ModalityType;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import com.connor.jd.plm.dialogs.BOMManagementFrame;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;

public class DialogUtil {

	public static TableMsg createTableMsg(String[] header, List<String[]> msgContent) {
		DefaultTableModel msgModel = new DefaultTableModel(header, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				// TODO Auto-generated method stub
				return false;
			}
		};
		JTable msgTable = new JTable(msgModel);
		for (int columnIndex = 0; columnIndex < msgTable.getColumnCount(); columnIndex++) {
			msgTable.getColumnModel().getColumn(columnIndex).setMinWidth(100);
		}
		msgTable.setRowHeight(25);
		msgTable.setShowGrid(false);
		msgTable.setAutoscrolls(true);
		msgTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		msgTable.getTableHeader().setReorderingAllowed(false);
//		msgTable.getTableHeader().setVisible(false);

		for (String[] row : msgContent) {
			msgModel.addRow(row);
		}

		msgTable.invalidate();
		msgTable.repaint();
		JScrollPane msgPanel = new JScrollPane(msgTable);
		msgPanel.setPreferredSize(new Dimension(header.length * 100, 200));
		msgPanel.setBorder(BorderFactory.createEmptyBorder());
		return new TableMsg(msgPanel, msgTable);
	}

	public static JDialog createSearchAndSelectRevDialog(BOMManagementFrame frame, JTable paramTable,
			JCheckBox selectAll, JButton field) {
		JDialog dialog = new JDialog();
		dialog.setTitle("汾");
		dialog.setSize(520, 400);
		dialog.setResizable(true);
		dialog.setAutoRequestFocus(true);
		dialog.setAlwaysOnTop(true);
		dialog.setLocationRelativeTo(frame);
		dialog.setModalityType(ModalityType.APPLICATION_MODAL);

		JPanel content = new JPanel();
		content.setLayout(null);
		content.setPreferredSize(new Dimension(520, 400));
		JLabel targetLabel = new JLabel("Ŀ");
		targetLabel.setBounds(10, 10, 50, 25);
		JTextField targetText = new JTextField();
		targetText.setText("ҪID");
		targetText.setForeground(Color.GRAY);
		if (!"".equals(field.getText())) {
			targetText.setText(field.getText().substring(0, field.getText().indexOf("/")));
			targetText.setForeground(Color.BLACK);
		}
		targetText.setBounds(20, 50, 300, 25);
		JButton searchBtn = new JButton("");
		searchBtn.setBounds(380, 50, 100, 25);

		String[] colDisplayNames = new String[] { "", "", "״̬", "", "ID", "" };
		DefaultTableModel model = new DefaultTableModel(colDisplayNames, 0) {
			@Override
			public boolean isCellEditable(int paramInt1, int paramInt2) {
				return false;
			}
		};
		JTable table = new JTable(model);
		table.getColumnModel().getColumn(0).setMinWidth(100);
		table.getColumnModel().getColumn(1).setMinWidth(100);
		table.getColumnModel().getColumn(2).setMinWidth(100);
		table.getColumnModel().getColumn(3).setMinWidth(100);
		table.getColumnModel().getColumn(4).setMinWidth(60);
		table.getColumnModel().getColumn(4).setPreferredWidth(60);
		TableColumnModel tcm = table.getColumnModel();
		TableColumn tc = tcm.getColumn(5);
		tc.setWidth(0);
		tc.setPreferredWidth(0);
		tc.setMaxWidth(0);
		tc.setMinWidth(0);
		table.getTableHeader().getColumnModel().getColumn(5).setMaxWidth(0);
		table.getTableHeader().getColumnModel().getColumn(5).setMinWidth(0);
		table.setRowHeight(25);
		table.setAutoscrolls(true);
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.getTableHeader().setReorderingAllowed(false);
		JScrollPane jsp = new JScrollPane(table);
		jsp.setBounds(20, 100, 460, 200);

		JButton okBtn = new JButton("ȷ");
		okBtn.setBounds(140, 320, 100, 25);
		JButton cancelBtn = new JButton("ȡ");
		cancelBtn.setBounds(260, 320, 100, 25);

		targetText.addFocusListener(new FocusListener() {

			@Override
			public void focusLost(FocusEvent e) {
				// TODO Auto-generated method stub
				if ("".equals(targetText.getText())) {
					targetText.setText("ҪID");
					targetText.setForeground(Color.GRAY);
				}
			}

			@Override
			public void focusGained(FocusEvent e) {
				// TODO Auto-generated method stub
				if ("ҪID".equals(targetText.getText())) {
					targetText.setText("");
					targetText.setForeground(Color.BLACK);
				}
			}
		});

		targetText.addKeyListener(new KeyAdapter() {
			@Override
			public void keyTyped(KeyEvent paramKeyEvent) {
				// TODO Auto-generated method stub
				super.keyTyped(paramKeyEvent);
				if (paramKeyEvent.getKeyChar() == KeyEvent.VK_ENTER) {
					searchBtn.doClick();
				}
			}
		});

		searchBtn.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int cnt = model.getRowCount();
				for (int i = 0; i < cnt; i++) {
					model.removeRow(0);
				}
				table.revalidate();
				table.repaint();
				String text = targetText.getText();
				System.out.println(text);
				if ("ҪID".equals(text)) {
					return;
				}
				long startTime = System.currentTimeMillis();
				TCSession session = (TCSession) AIFUtility.getCurrentApplication().getSession();
				TCComponentItem[] items = getTarget(content, text, session);
				if (items == null) {
					return;
				}
				List<Object[]> tableDataList = new ArrayList<Object[]>();
				for (TCComponentItem item : items) {
					try {
						TCComponent[] comps = item.getRelatedComponents("revision_list");
						for (TCComponent comp : comps) {
							String objetcString = comp.getProperty("object_string");
							TCComponent[] forms = comp.getRelatedComponents("IMAN_master_form_rev");
							String desc = "";
							if (forms.length > 0) {
								desc = forms[0].getProperty("jd2_wlms");
							}
							TCComponent[] statusArray = comp.getRelatedComponents("release_status_list");
							String status = "";
							if (statusArray != null && statusArray.length > 0) {
								status = statusArray[statusArray.length - 1].getProperty("object_name");
							}
							String owningUser = comp.getProperty("owning_user");
							String groupId = comp.getProperty("owning_group");
							tableDataList.add(new Object[] { objetcString, desc, status, owningUser, groupId, comp });
						}
					} catch (TCException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				for (Object[] rowData : tableDataList) {
					model.addRow(rowData);
				}
				table.revalidate();
				table.repaint();
				System.out.println("ʾʱ" + (System.currentTimeMillis() - startTime) + "ms");
			}
		});

		okBtn.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent paramActionEvent) {
				// TODO Auto-generated method stub
				frame.okCallback(table, paramTable, selectAll, field);
//				dialog.setVisible(false);
				dialog.dispose();
			}
		});

		cancelBtn.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent paramActionEvent) {
				// TODO Auto-generated method stub
//				dialog.setVisible(false);
				dialog.dispose();
			}
		});

		content.add(targetLabel);
		content.add(targetText);
		content.add(searchBtn);
		content.add(jsp);
		content.add(okBtn);
		content.add(cancelBtn);

		dialog.add(content);
		dialog.setVisible(true);

		return dialog;
	}

	private static TCComponentItem[] getTarget(Component parent, String itemId, TCSession session) {
		TCComponent[] comps = null;
		try {
			comps = session.search("Item ID", new String[] { " ID" }, new String[] { itemId });
//			TCComponentItemType type = new TCComponentItemType();
//			comps = type.findItems(itemId);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			return null;
		}
		if (comps == null || comps.length == 0) {
			JOptionPane.showMessageDialog(parent, "Чϱ룬ȷϱǷȷ", "ʾ", JOptionPane.WARNING_MESSAGE);
			return null;
		}
		TCComponentItem[] items = new TCComponentItem[comps.length];
		for (int i = 0; i < comps.length; i++) {
			items[i] = (TCComponentItem) comps[i];
		}
		return items;
	}

	public static class TableMsg {
		public JScrollPane panel;
		public JTable table;

		public TableMsg(JScrollPane panel, JTable table) {
			super();
			this.panel = panel;
			this.table = table;
		}

	}
}
